﻿using System;
using System.Drawing;


namespace TechnicalTools
{
    public static class Color_Extensions
    {
        delegate byte ComponentSelector(Color color);

        static readonly ComponentSelector AlphaSelector = color => color.A;
        static readonly ComponentSelector RedSelector = color => color.R;
        static readonly ComponentSelector GreenSelector = color => color.G;
        static readonly ComponentSelector BlueSelector = color => color.B;

        /// <summary>
        /// Get a Color between to color using a value indicating how far from start color  we have to get the color
        /// </summary>
        /// <param name="from">Start color</param>
        /// <param name="toColor">End Color</param>
        /// <param name="lambda">Value between 0 and 1 indicating how far from start color we have to get the color. if lambda = 0 start color is returned, if lambda = 1 end color is returned.</param>
        public static Color InterpolateTo(this Color from, Color toColor, double lambda)
        {
            if (lambda < 0 || lambda > 1)
                throw new ArgumentOutOfRangeException("lambda");

            Color color = Color.FromArgb(from.A,//InterpolateComponent(from, toColor, lambda, AlphaSelector),
                                         InterpolateComponent(from, toColor, lambda, RedSelector),
                                         InterpolateComponent(from, toColor, lambda, GreenSelector),
                                         InterpolateComponent(from, toColor, lambda, BlueSelector));
            return color;
        }

        static byte InterpolateComponent(Color endPoint1, Color endPoint2, double lambda, ComponentSelector selector)
        {
            return (byte)(selector(endPoint1)
                 + lambda * (selector(endPoint2) - selector(endPoint1)));
        }

        public static Color MakeLighter(this Color c, float ligtherFactor = 0.5f)
        {
            var hsl = c.ToHSL();
            hsl.Luminosity *= (1 + ligtherFactor);
            c = hsl.ToRGB();
            return c;
        }

        public static string ToHexString(this Color c) => $"#{c.R:X2}{c.G:X2}{c.B:X2}";

        public static string ToRgbString(this Color c) => $"RGB({c.R}, {c.G}, {c.B})";

        // From 64 colors array here : https://stackoverflow.com/a/12224359/294998
        // generated with CIELab Delta2000 / Starting with black
        // Tips: skip the first 4 colors
        public static readonly Color[] DistinctColors64 = new Color[]
        {
            Color.FromArgb(unchecked((int)0xFF000000)),
            Color.FromArgb(unchecked((int)0xFF00FF00)),
            Color.FromArgb(unchecked((int)0xFF0000FF)),
            Color.FromArgb(unchecked((int)0xFFFF0000)),
            Color.FromArgb(unchecked((int)0xFF01FFFE)),
            Color.FromArgb(unchecked((int)0xFFFFA6FE)),
            Color.FromArgb(unchecked((int)0xFFFFDB66)),
            Color.FromArgb(unchecked((int)0xFF006401)),
            Color.FromArgb(unchecked((int)0xFF010067)),
            Color.FromArgb(unchecked((int)0xFF95003A)),
            Color.FromArgb(unchecked((int)0xFF007DB5)),
            Color.FromArgb(unchecked((int)0xFFFF00F6)),
            Color.FromArgb(unchecked((int)0xFFFFEEE8)),
            Color.FromArgb(unchecked((int)0xFF774D00)),
            Color.FromArgb(unchecked((int)0xFF90FB92)),
            Color.FromArgb(unchecked((int)0xFF0076FF)),
            Color.FromArgb(unchecked((int)0xFFD5FF00)),
            Color.FromArgb(unchecked((int)0xFFFF937E)),
            Color.FromArgb(unchecked((int)0xFF6A826C)),
            Color.FromArgb(unchecked((int)0xFFFF029D)),
            Color.FromArgb(unchecked((int)0xFFFE8900)),
            Color.FromArgb(unchecked((int)0xFF7A4782)),
            Color.FromArgb(unchecked((int)0xFF7E2DD2)),
            Color.FromArgb(unchecked((int)0xFF85A900)),
            Color.FromArgb(unchecked((int)0xFFFF0056)),
            Color.FromArgb(unchecked((int)0xFFA42400)),
            Color.FromArgb(unchecked((int)0xFF00AE7E)),
            Color.FromArgb(unchecked((int)0xFF683D3B)),
            Color.FromArgb(unchecked((int)0xFFBDC6FF)),
            Color.FromArgb(unchecked((int)0xFF263400)),
            Color.FromArgb(unchecked((int)0xFFBDD393)),
            Color.FromArgb(unchecked((int)0xFF00B917)),
            Color.FromArgb(unchecked((int)0xFF9E008E)),
            Color.FromArgb(unchecked((int)0xFF001544)),
            Color.FromArgb(unchecked((int)0xFFC28C9F)),
            Color.FromArgb(unchecked((int)0xFFFF74A3)),
            Color.FromArgb(unchecked((int)0xFF01D0FF)),
            Color.FromArgb(unchecked((int)0xFF004754)),
            Color.FromArgb(unchecked((int)0xFFE56FFE)),
            Color.FromArgb(unchecked((int)0xFF788231)),
            Color.FromArgb(unchecked((int)0xFF0E4CA1)),
            Color.FromArgb(unchecked((int)0xFF91D0CB)),
            Color.FromArgb(unchecked((int)0xFFBE9970)),
            Color.FromArgb(unchecked((int)0xFF968AE8)),
            Color.FromArgb(unchecked((int)0xFFBB8800)),
            Color.FromArgb(unchecked((int)0xFF43002C)),
            Color.FromArgb(unchecked((int)0xFFDEFF74)),
            Color.FromArgb(unchecked((int)0xFF00FFC6)),
            Color.FromArgb(unchecked((int)0xFFFFE502)),
            Color.FromArgb(unchecked((int)0xFF620E00)),
            Color.FromArgb(unchecked((int)0xFF008F9C)),
            Color.FromArgb(unchecked((int)0xFF98FF52)),
            Color.FromArgb(unchecked((int)0xFF7544B1)),
            Color.FromArgb(unchecked((int)0xFFB500FF)),
            Color.FromArgb(unchecked((int)0xFF00FF78)),
            Color.FromArgb(unchecked((int)0xFFFF6E41)),
            Color.FromArgb(unchecked((int)0xFF005F39)),
            Color.FromArgb(unchecked((int)0xFF6B6882)),
            Color.FromArgb(unchecked((int)0xFF5FAD4E)),
            Color.FromArgb(unchecked((int)0xFFA75740)),
            Color.FromArgb(unchecked((int)0xFFA5FFD2)),
            Color.FromArgb(unchecked((int)0xFFFFB167)),
            Color.FromArgb(unchecked((int)0xFF009BFF)),
            Color.FromArgb(unchecked((int)0xFFE85EBE)),
        };

        // From 729 colors array here : https://stackoverflow.com/a/12224359/294998
        // Using CIELab2000
        public static readonly Color[] DistinctColors729 = new Color[]
        {
            Color.FromArgb(unchecked((int)0xFF9BC4E5)),
            Color.FromArgb(unchecked((int)0xFF310106)),
            Color.FromArgb(unchecked((int)0xFF04640D)),
            Color.FromArgb(unchecked((int)0xFFFEFB0A)),
            Color.FromArgb(unchecked((int)0xFFFB5514)),
            Color.FromArgb(unchecked((int)0xFFE115C0)),
            Color.FromArgb(unchecked((int)0xFF00587F)),
            Color.FromArgb(unchecked((int)0xFF0BC582)),
            Color.FromArgb(unchecked((int)0xFFFEB8C8)),
            Color.FromArgb(unchecked((int)0xFF9E8317)),
            Color.FromArgb(unchecked((int)0xFF01190F)),
            Color.FromArgb(unchecked((int)0xFF847D81)),
            Color.FromArgb(unchecked((int)0xFF58018B)),
            Color.FromArgb(unchecked((int)0xFFB70639)),
            Color.FromArgb(unchecked((int)0xFF703B01)),
            Color.FromArgb(unchecked((int)0xFFF7F1DF)),
            Color.FromArgb(unchecked((int)0xFF118B8A)),
            Color.FromArgb(unchecked((int)0xFF4AFEFA)),
            Color.FromArgb(unchecked((int)0xFFFCB164)),
            Color.FromArgb(unchecked((int)0xFF796EE6)),
            Color.FromArgb(unchecked((int)0xFF000D2C)),
            Color.FromArgb(unchecked((int)0xFF53495F)),
            Color.FromArgb(unchecked((int)0xFFF95475)),
            Color.FromArgb(unchecked((int)0xFF61FC03)),
            Color.FromArgb(unchecked((int)0xFF5D9608)),
            Color.FromArgb(unchecked((int)0xFFDE98FD)),
            Color.FromArgb(unchecked((int)0xFF98A088)),
            Color.FromArgb(unchecked((int)0xFF4F584E)),
            Color.FromArgb(unchecked((int)0xFF248AD0)),
            Color.FromArgb(unchecked((int)0xFF5C5300)),
            Color.FromArgb(unchecked((int)0xFF9F6551)),
            Color.FromArgb(unchecked((int)0xFFBCFEC6)),
            Color.FromArgb(unchecked((int)0xFF932C70)),
            Color.FromArgb(unchecked((int)0xFF2B1B04)),
            Color.FromArgb(unchecked((int)0xFFB5AFC4)),
            Color.FromArgb(unchecked((int)0xFFD4C67A)),
            Color.FromArgb(unchecked((int)0xFFAE7AA1)),
            Color.FromArgb(unchecked((int)0xFFC2A393)),
            Color.FromArgb(unchecked((int)0xFF0232FD)),
            Color.FromArgb(unchecked((int)0xFF6A3A35)),
            Color.FromArgb(unchecked((int)0xFFBA6801)),
            Color.FromArgb(unchecked((int)0xFF168E5C)),
            Color.FromArgb(unchecked((int)0xFF16C0D0)),
            Color.FromArgb(unchecked((int)0xFFC62100)),
            Color.FromArgb(unchecked((int)0xFF014347)),
            Color.FromArgb(unchecked((int)0xFF233809)),
            Color.FromArgb(unchecked((int)0xFF42083B)),
            Color.FromArgb(unchecked((int)0xFF82785D)),
            Color.FromArgb(unchecked((int)0xFF023087)),
            Color.FromArgb(unchecked((int)0xFFB7DAD2)),
            Color.FromArgb(unchecked((int)0xFF196956)),
            Color.FromArgb(unchecked((int)0xFF8C41BB)),
            Color.FromArgb(unchecked((int)0xFFECEDFE)),
            Color.FromArgb(unchecked((int)0xFF2B2D32)),
            Color.FromArgb(unchecked((int)0xFF94C661)),
            Color.FromArgb(unchecked((int)0xFFF8907D)),
            Color.FromArgb(unchecked((int)0xFF895E6B)),
            Color.FromArgb(unchecked((int)0xFF788E95)),
            Color.FromArgb(unchecked((int)0xFFFB6AB8)),
            Color.FromArgb(unchecked((int)0xFF576094)),
            Color.FromArgb(unchecked((int)0xFFDB1474)),
            Color.FromArgb(unchecked((int)0xFF8489AE)),
            Color.FromArgb(unchecked((int)0xFF860E04)),
            Color.FromArgb(unchecked((int)0xFFFBC206)),
            Color.FromArgb(unchecked((int)0xFF6EAB9B)),
            Color.FromArgb(unchecked((int)0xFFF2CDFE)),
            Color.FromArgb(unchecked((int)0xFF645341)),
            Color.FromArgb(unchecked((int)0xFF760035)),
            Color.FromArgb(unchecked((int)0xFF647A41)),
            Color.FromArgb(unchecked((int)0xFF496E76)),
            Color.FromArgb(unchecked((int)0xFFE3F894)),
            Color.FromArgb(unchecked((int)0xFFF9D7CD)),
            Color.FromArgb(unchecked((int)0xFF876128)),
            Color.FromArgb(unchecked((int)0xFFA1A711)),
            Color.FromArgb(unchecked((int)0xFF01FB92)),
            Color.FromArgb(unchecked((int)0xFFFD0F31)),
            Color.FromArgb(unchecked((int)0xFFBE8485)),
            Color.FromArgb(unchecked((int)0xFFC660FB)),
            Color.FromArgb(unchecked((int)0xFF120104)),
            Color.FromArgb(unchecked((int)0xFFD48958)),
            Color.FromArgb(unchecked((int)0xFF05AEE8)),
            Color.FromArgb(unchecked((int)0xFFC3C1BE)),
            Color.FromArgb(unchecked((int)0xFF9F98F8)),
            Color.FromArgb(unchecked((int)0xFF1167D9)),
            Color.FromArgb(unchecked((int)0xFFD19012)),
            Color.FromArgb(unchecked((int)0xFFB7D802)),
            Color.FromArgb(unchecked((int)0xFF826392)),
            Color.FromArgb(unchecked((int)0xFF5E7A6A)),
            Color.FromArgb(unchecked((int)0xFFB29869)),
            Color.FromArgb(unchecked((int)0xFF1D0051)),
            Color.FromArgb(unchecked((int)0xFF8BE7FC)),
            Color.FromArgb(unchecked((int)0xFF76E0C1)),
            Color.FromArgb(unchecked((int)0xFFBACFA7)),
            Color.FromArgb(unchecked((int)0xFF11BA09)),
            Color.FromArgb(unchecked((int)0xFF462C36)),
            Color.FromArgb(unchecked((int)0xFF65407D)),
            Color.FromArgb(unchecked((int)0xFF491803)),
            Color.FromArgb(unchecked((int)0xFFF5D2A8)),
            Color.FromArgb(unchecked((int)0xFF03422C)),
            Color.FromArgb(unchecked((int)0xFF72A46E)),
            Color.FromArgb(unchecked((int)0xFF128EAC)),
            Color.FromArgb(unchecked((int)0xFF47545E)),
            Color.FromArgb(unchecked((int)0xFFB95C69)),
            Color.FromArgb(unchecked((int)0xFFA14D12)),
            Color.FromArgb(unchecked((int)0xFFC4C8FA)),
            Color.FromArgb(unchecked((int)0xFF372A55)),
            Color.FromArgb(unchecked((int)0xFF3F3610)),
            Color.FromArgb(unchecked((int)0xFFD3A2C6)),
            Color.FromArgb(unchecked((int)0xFF719FFA)),
            Color.FromArgb(unchecked((int)0xFF0D841A)),
            Color.FromArgb(unchecked((int)0xFF4C5B32)),
            Color.FromArgb(unchecked((int)0xFF9DB3B7)),
            Color.FromArgb(unchecked((int)0xFFB14F8F)),
            Color.FromArgb(unchecked((int)0xFF747103)),
            Color.FromArgb(unchecked((int)0xFF9F816D)),
            Color.FromArgb(unchecked((int)0xFFD26A5B)),
            Color.FromArgb(unchecked((int)0xFF8B934B)),
            Color.FromArgb(unchecked((int)0xFFF98500)),
            Color.FromArgb(unchecked((int)0xFF002935)),
            Color.FromArgb(unchecked((int)0xFFD7F3FE)),
            Color.FromArgb(unchecked((int)0xFFFCB899)),
            Color.FromArgb(unchecked((int)0xFF1C0720)),
            Color.FromArgb(unchecked((int)0xFF6B5F61)),
            Color.FromArgb(unchecked((int)0xFFF98A9D)),
            Color.FromArgb(unchecked((int)0xFF9B72C2)),
            Color.FromArgb(unchecked((int)0xFFA6919D)),
            Color.FromArgb(unchecked((int)0xFF2C3729)),
            Color.FromArgb(unchecked((int)0xFFD7C70B)),
            Color.FromArgb(unchecked((int)0xFF9F9992)),
            Color.FromArgb(unchecked((int)0xFFEFFBD0)),
            Color.FromArgb(unchecked((int)0xFFFDE2F1)),
            Color.FromArgb(unchecked((int)0xFF923A52)),
            Color.FromArgb(unchecked((int)0xFF5140A7)),
            Color.FromArgb(unchecked((int)0xFFBC14FD)),
            Color.FromArgb(unchecked((int)0xFF6D706C)),
            Color.FromArgb(unchecked((int)0xFF0007C4)),
            Color.FromArgb(unchecked((int)0xFFC6A62F)),
            Color.FromArgb(unchecked((int)0xFF000C14)),
            Color.FromArgb(unchecked((int)0xFF904431)),
            Color.FromArgb(unchecked((int)0xFF600013)),
            Color.FromArgb(unchecked((int)0xFF1C1B08)),
            Color.FromArgb(unchecked((int)0xFF693955)),
            Color.FromArgb(unchecked((int)0xFF5E7C99)),
            Color.FromArgb(unchecked((int)0xFF6C6E82)),
            Color.FromArgb(unchecked((int)0xFFD0AFB3)),
            Color.FromArgb(unchecked((int)0xFF493B36)),
            Color.FromArgb(unchecked((int)0xFFAC93CE)),
            Color.FromArgb(unchecked((int)0xFFC4BA9C)),
            Color.FromArgb(unchecked((int)0xFF09C4B8)),
            Color.FromArgb(unchecked((int)0xFF69A5B8)),
            Color.FromArgb(unchecked((int)0xFF374869)),
            Color.FromArgb(unchecked((int)0xFFF868ED)),
            Color.FromArgb(unchecked((int)0xFFE70850)),
            Color.FromArgb(unchecked((int)0xFFC04841)),
            Color.FromArgb(unchecked((int)0xFFC36333)),
            Color.FromArgb(unchecked((int)0xFF700366)),
            Color.FromArgb(unchecked((int)0xFF8A7A93)),
            Color.FromArgb(unchecked((int)0xFF52351D)),
            Color.FromArgb(unchecked((int)0xFFB503A2)),
            Color.FromArgb(unchecked((int)0xFFD17190)),
            Color.FromArgb(unchecked((int)0xFFA0F086)),
            Color.FromArgb(unchecked((int)0xFF7B41FC)),
            Color.FromArgb(unchecked((int)0xFF0EA64F)),
            Color.FromArgb(unchecked((int)0xFF017499)),
            Color.FromArgb(unchecked((int)0xFF08A882)),
            Color.FromArgb(unchecked((int)0xFF7300CD)),
            Color.FromArgb(unchecked((int)0xFFA9B074)),
            Color.FromArgb(unchecked((int)0xFF4E6301)),
            Color.FromArgb(unchecked((int)0xFFAB7E41)),
            Color.FromArgb(unchecked((int)0xFF547FF4)),
            Color.FromArgb(unchecked((int)0xFF134DAC)),
            Color.FromArgb(unchecked((int)0xFFFDEC87)),
            Color.FromArgb(unchecked((int)0xFF056164)),
            Color.FromArgb(unchecked((int)0xFFFE12A0)),
            Color.FromArgb(unchecked((int)0xFFC264BA)),
            Color.FromArgb(unchecked((int)0xFF939DAD)),
            Color.FromArgb(unchecked((int)0xFF0BCDFA)),
            Color.FromArgb(unchecked((int)0xFF277442)),
            Color.FromArgb(unchecked((int)0xFF1BDE4A)),
            Color.FromArgb(unchecked((int)0xFF826958)),
            Color.FromArgb(unchecked((int)0xFF977678)),
            Color.FromArgb(unchecked((int)0xFFBAFCE8)),
            Color.FromArgb(unchecked((int)0xFF7D8475)),
            Color.FromArgb(unchecked((int)0xFF8CCF95)),
            Color.FromArgb(unchecked((int)0xFF726638)),
            Color.FromArgb(unchecked((int)0xFFFEA8EB)),
            Color.FromArgb(unchecked((int)0xFFEAFEF0)),
            Color.FromArgb(unchecked((int)0xFF6B9279)),
            Color.FromArgb(unchecked((int)0xFFC2FE4B)),
            Color.FromArgb(unchecked((int)0xFF304041)),
            Color.FromArgb(unchecked((int)0xFF1EA6A7)),
            Color.FromArgb(unchecked((int)0xFF022403)),
            Color.FromArgb(unchecked((int)0xFF062A47)),
            Color.FromArgb(unchecked((int)0xFF054B17)),
            Color.FromArgb(unchecked((int)0xFFF4C673)),
            Color.FromArgb(unchecked((int)0xFF02FEC7)),
            Color.FromArgb(unchecked((int)0xFF9DBAA8)),
            Color.FromArgb(unchecked((int)0xFF775551)),
            Color.FromArgb(unchecked((int)0xFF835536)),
            Color.FromArgb(unchecked((int)0xFF565BCC)),
            Color.FromArgb(unchecked((int)0xFF80D7D2)),
            Color.FromArgb(unchecked((int)0xFF7AD607)),
            Color.FromArgb(unchecked((int)0xFF696F54)),
            Color.FromArgb(unchecked((int)0xFF87089A)),
            Color.FromArgb(unchecked((int)0xFF664B19)),
            Color.FromArgb(unchecked((int)0xFF242235)),
            Color.FromArgb(unchecked((int)0xFF7DB00D)),
            Color.FromArgb(unchecked((int)0xFFBFC7D6)),
            Color.FromArgb(unchecked((int)0xFFD5A97E)),
            Color.FromArgb(unchecked((int)0xFF433F31)),
            Color.FromArgb(unchecked((int)0xFF311A18)),
            Color.FromArgb(unchecked((int)0xFFFDB2AB)),
            Color.FromArgb(unchecked((int)0xFFD586C9)),
            Color.FromArgb(unchecked((int)0xFF7A5FB1)),
            Color.FromArgb(unchecked((int)0xFF32544A)),
            Color.FromArgb(unchecked((int)0xFFEFE3AF)),
            Color.FromArgb(unchecked((int)0xFF859D96)),
            Color.FromArgb(unchecked((int)0xFF2B8570)),
            Color.FromArgb(unchecked((int)0xFF8B282D)),
            Color.FromArgb(unchecked((int)0xFFE16A07)),
            Color.FromArgb(unchecked((int)0xFF4B0125)),
            Color.FromArgb(unchecked((int)0xFF021083)),
            Color.FromArgb(unchecked((int)0xFF114558)),
            Color.FromArgb(unchecked((int)0xFFF707F9)),
            Color.FromArgb(unchecked((int)0xFFC78571)),
            Color.FromArgb(unchecked((int)0xFF7FB9BC)),
            Color.FromArgb(unchecked((int)0xFFFC7F4B)),
            Color.FromArgb(unchecked((int)0xFF8D4A92)),
            Color.FromArgb(unchecked((int)0xFF6B3119)),
            Color.FromArgb(unchecked((int)0xFF884F74)),
            Color.FromArgb(unchecked((int)0xFF994E4F)),
            Color.FromArgb(unchecked((int)0xFF9DA9D3)),
            Color.FromArgb(unchecked((int)0xFF867B40)),
            Color.FromArgb(unchecked((int)0xFFCED5C4)),
            Color.FromArgb(unchecked((int)0xFF1CA2FE)),
            Color.FromArgb(unchecked((int)0xFFD9C5B4)),
            Color.FromArgb(unchecked((int)0xFFFEAA00)),
            Color.FromArgb(unchecked((int)0xFF507B01)),
            Color.FromArgb(unchecked((int)0xFFA7D0DB)),
            Color.FromArgb(unchecked((int)0xFF53858D)),
            Color.FromArgb(unchecked((int)0xFF588F4A)),
            Color.FromArgb(unchecked((int)0xFFFBEEEC)),
            Color.FromArgb(unchecked((int)0xFFFC93C1)),
            Color.FromArgb(unchecked((int)0xFFD7CCD4)),
            Color.FromArgb(unchecked((int)0xFF3E4A02)),
            Color.FromArgb(unchecked((int)0xFFC8B1E2)),
            Color.FromArgb(unchecked((int)0xFF7A8B62)),
            Color.FromArgb(unchecked((int)0xFF9A5AE2)),
            Color.FromArgb(unchecked((int)0xFF896C04)),
            Color.FromArgb(unchecked((int)0xFFB1121C)),
            Color.FromArgb(unchecked((int)0xFF402D7D)),
            Color.FromArgb(unchecked((int)0xFF858701)),
            Color.FromArgb(unchecked((int)0xFFD498A6)),
            Color.FromArgb(unchecked((int)0xFFB484EF)),
            Color.FromArgb(unchecked((int)0xFF5C474C)),
            Color.FromArgb(unchecked((int)0xFF067881)),
            Color.FromArgb(unchecked((int)0xFFC0F9FC)),
            Color.FromArgb(unchecked((int)0xFF726075)),
            Color.FromArgb(unchecked((int)0xFF8D3101)),
            Color.FromArgb(unchecked((int)0xFF6C93B2)),
            Color.FromArgb(unchecked((int)0xFFA26B3F)),
            Color.FromArgb(unchecked((int)0xFFAA6582)),
            Color.FromArgb(unchecked((int)0xFF4F4C4F)),
            Color.FromArgb(unchecked((int)0xFF5A563D)),
            Color.FromArgb(unchecked((int)0xFFE83005)),
            Color.FromArgb(unchecked((int)0xFF32492D)),
            Color.FromArgb(unchecked((int)0xFFFC7272)),
            Color.FromArgb(unchecked((int)0xFFB9C457)),
            Color.FromArgb(unchecked((int)0xFF552A5B)),
            Color.FromArgb(unchecked((int)0xFFB50464)),
            Color.FromArgb(unchecked((int)0xFF616E79)),
            Color.FromArgb(unchecked((int)0xFFDCE2E4)),
            Color.FromArgb(unchecked((int)0xFFCF8028)),
            Color.FromArgb(unchecked((int)0xFF0AE2F0)),
            Color.FromArgb(unchecked((int)0xFF4F1E24)),
            Color.FromArgb(unchecked((int)0xFFFD5E46)),
            Color.FromArgb(unchecked((int)0xFF4B694E)),
            Color.FromArgb(unchecked((int)0xFFC5DEFC)),
            Color.FromArgb(unchecked((int)0xFF5DC262)),
            Color.FromArgb(unchecked((int)0xFF022D26)),
            Color.FromArgb(unchecked((int)0xFF7776B8)),
            Color.FromArgb(unchecked((int)0xFFFD9F66)),
            Color.FromArgb(unchecked((int)0xFFB049B8)),
            Color.FromArgb(unchecked((int)0xFF988F73)),
            Color.FromArgb(unchecked((int)0xFFBE385A)),
            Color.FromArgb(unchecked((int)0xFF2B2126)),
            Color.FromArgb(unchecked((int)0xFF54805A)),
            Color.FromArgb(unchecked((int)0xFF141B55)),
            Color.FromArgb(unchecked((int)0xFF67C09B)),
            Color.FromArgb(unchecked((int)0xFF456989)),
            Color.FromArgb(unchecked((int)0xFFDDC1D9)),
            Color.FromArgb(unchecked((int)0xFF166175)),
            Color.FromArgb(unchecked((int)0xFFC1E29C)),
            Color.FromArgb(unchecked((int)0xFFA397B5)),
            Color.FromArgb(unchecked((int)0xFF2E2922)),
            Color.FromArgb(unchecked((int)0xFFABDBBE)),
            Color.FromArgb(unchecked((int)0xFFB4A6A8)),
            Color.FromArgb(unchecked((int)0xFFA06B07)),
            Color.FromArgb(unchecked((int)0xFFA99949)),
            Color.FromArgb(unchecked((int)0xFF0A0618)),
            Color.FromArgb(unchecked((int)0xFFB14E2E)),
            Color.FromArgb(unchecked((int)0xFF60557D)),
            Color.FromArgb(unchecked((int)0xFFD4A556)),
            Color.FromArgb(unchecked((int)0xFF82A752)),
            Color.FromArgb(unchecked((int)0xFF4A005B)),
            Color.FromArgb(unchecked((int)0xFF3C404F)),
            Color.FromArgb(unchecked((int)0xFF6E6657)),
            Color.FromArgb(unchecked((int)0xFF7E8BD5)),
            Color.FromArgb(unchecked((int)0xFF1275B8)),
            Color.FromArgb(unchecked((int)0xFFD79E92)),
            Color.FromArgb(unchecked((int)0xFF230735)),
            Color.FromArgb(unchecked((int)0xFF661849)),
            Color.FromArgb(unchecked((int)0xFF7A8391)),
            Color.FromArgb(unchecked((int)0xFFFE0F7B)),
            Color.FromArgb(unchecked((int)0xFFB0B6A9)),
            Color.FromArgb(unchecked((int)0xFF629591)),
            Color.FromArgb(unchecked((int)0xFFD05591)),
            Color.FromArgb(unchecked((int)0xFF97B68A)),
            Color.FromArgb(unchecked((int)0xFF97939A)),
            Color.FromArgb(unchecked((int)0xFF035E38)),
            Color.FromArgb(unchecked((int)0xFF53E19E)),
            Color.FromArgb(unchecked((int)0xFFDFD7F9)),
            Color.FromArgb(unchecked((int)0xFF02436C)),
            Color.FromArgb(unchecked((int)0xFF525A72)),
            Color.FromArgb(unchecked((int)0xFF059A0E)),
            Color.FromArgb(unchecked((int)0xFF3E736C)),
            Color.FromArgb(unchecked((int)0xFFAC8E87)),
            Color.FromArgb(unchecked((int)0xFFD10C92)),
            Color.FromArgb(unchecked((int)0xFFB9906E)),
            Color.FromArgb(unchecked((int)0xFF66BDFD)),
            Color.FromArgb(unchecked((int)0xFFC0ABFD)),
            Color.FromArgb(unchecked((int)0xFF0734BC)),
            Color.FromArgb(unchecked((int)0xFF341224)),
            Color.FromArgb(unchecked((int)0xFF8AAAC1)),
            Color.FromArgb(unchecked((int)0xFF0E0B03)),
            Color.FromArgb(unchecked((int)0xFF414522)),
            Color.FromArgb(unchecked((int)0xFF6A2F3E)),
            Color.FromArgb(unchecked((int)0xFF2D9A8A)),
            Color.FromArgb(unchecked((int)0xFF4568FD)),
            Color.FromArgb(unchecked((int)0xFFFDE6D2)),
            Color.FromArgb(unchecked((int)0xFFFEE007)),
            Color.FromArgb(unchecked((int)0xFF9A003C)),
            Color.FromArgb(unchecked((int)0xFFAC8190)),
            Color.FromArgb(unchecked((int)0xFFDCDD58)),
            Color.FromArgb(unchecked((int)0xFFB7903D)),
            Color.FromArgb(unchecked((int)0xFF1F2927)),
            Color.FromArgb(unchecked((int)0xFF9B02E6)),
            Color.FromArgb(unchecked((int)0xFF827A71)),
            Color.FromArgb(unchecked((int)0xFF878B8A)),
            Color.FromArgb(unchecked((int)0xFF8F724F)),
            Color.FromArgb(unchecked((int)0xFFAC4B70)),
            Color.FromArgb(unchecked((int)0xFF37233B)),
            Color.FromArgb(unchecked((int)0xFF385559)),
            Color.FromArgb(unchecked((int)0xFFF347C7)),
            Color.FromArgb(unchecked((int)0xFF9DB4FE)),
            Color.FromArgb(unchecked((int)0xFFD57179)),
            Color.FromArgb(unchecked((int)0xFFDE505A)),
            Color.FromArgb(unchecked((int)0xFF37F7DD)),
            Color.FromArgb(unchecked((int)0xFF503500)),
            Color.FromArgb(unchecked((int)0xFF1C2401)),
            Color.FromArgb(unchecked((int)0xFFDD0323)),
            Color.FromArgb(unchecked((int)0xFF00A4BA)),
            Color.FromArgb(unchecked((int)0xFF955602)),
            Color.FromArgb(unchecked((int)0xFFFA5B94)),
            Color.FromArgb(unchecked((int)0xFFAA766C)),
            Color.FromArgb(unchecked((int)0xFFB8E067)),
            Color.FromArgb(unchecked((int)0xFF6A807E)),
            Color.FromArgb(unchecked((int)0xFF4D2E27)),
            Color.FromArgb(unchecked((int)0xFF73BED7)),
            Color.FromArgb(unchecked((int)0xFFD7BC8A)),
            Color.FromArgb(unchecked((int)0xFF614539)),
            Color.FromArgb(unchecked((int)0xFF526861)),
            Color.FromArgb(unchecked((int)0xFF716D96)),
            Color.FromArgb(unchecked((int)0xFF829A17)),
            Color.FromArgb(unchecked((int)0xFF210109)),
            Color.FromArgb(unchecked((int)0xFF436C2D)),
            Color.FromArgb(unchecked((int)0xFF784955)),
            Color.FromArgb(unchecked((int)0xFF987BAB)),
            Color.FromArgb(unchecked((int)0xFF8F0152)),
            Color.FromArgb(unchecked((int)0xFF0452FA)),
            Color.FromArgb(unchecked((int)0xFFB67757)),
            Color.FromArgb(unchecked((int)0xFFA1659F)),
            Color.FromArgb(unchecked((int)0xFFD4F8D8)),
            Color.FromArgb(unchecked((int)0xFF48416F)),
            Color.FromArgb(unchecked((int)0xFFDEBAAF)),
            Color.FromArgb(unchecked((int)0xFFA5A9AA)),
            Color.FromArgb(unchecked((int)0xFF8C6B83)),
            Color.FromArgb(unchecked((int)0xFF403740)),
            Color.FromArgb(unchecked((int)0xFF70872B)),
            Color.FromArgb(unchecked((int)0xFFD9744D)),
            Color.FromArgb(unchecked((int)0xFF151E2C)),
            Color.FromArgb(unchecked((int)0xFF5C5E5E)),
            Color.FromArgb(unchecked((int)0xFFB47C02)),
            Color.FromArgb(unchecked((int)0xFFF4CBD0)),
            Color.FromArgb(unchecked((int)0xFFE49D7D)),
            Color.FromArgb(unchecked((int)0xFFDD9954)),
            Color.FromArgb(unchecked((int)0xFFB0A18B)),
            Color.FromArgb(unchecked((int)0xFF2B5308)),
            Color.FromArgb(unchecked((int)0xFFEDFD64)),
            Color.FromArgb(unchecked((int)0xFF9D72FC)),
            Color.FromArgb(unchecked((int)0xFF2A3351)),
            Color.FromArgb(unchecked((int)0xFF68496C)),
            Color.FromArgb(unchecked((int)0xFFC94801)),
            Color.FromArgb(unchecked((int)0xFFEED05E)),
            Color.FromArgb(unchecked((int)0xFF826F6D)),
            Color.FromArgb(unchecked((int)0xFFE0D6BB)),
            Color.FromArgb(unchecked((int)0xFF5B6DB4)),
            Color.FromArgb(unchecked((int)0xFF662F98)),
            Color.FromArgb(unchecked((int)0xFF0C97CA)),
            Color.FromArgb(unchecked((int)0xFFC1CA89)),
            Color.FromArgb(unchecked((int)0xFF755A03)),
            Color.FromArgb(unchecked((int)0xFFDFA619)),
            Color.FromArgb(unchecked((int)0xFFCD70A8)),
            Color.FromArgb(unchecked((int)0xFFBBC9C7)),
            Color.FromArgb(unchecked((int)0xFFF6BCE3)),
            Color.FromArgb(unchecked((int)0xFFA16462)),
            Color.FromArgb(unchecked((int)0xFF01D0AA)),
            Color.FromArgb(unchecked((int)0xFF87C6B3)),
            Color.FromArgb(unchecked((int)0xFFE7B2FA)),
            Color.FromArgb(unchecked((int)0xFFD85379)),
            Color.FromArgb(unchecked((int)0xFF643AD5)),
            Color.FromArgb(unchecked((int)0xFFD18AAE)),
            Color.FromArgb(unchecked((int)0xFF13FD5E)),
            Color.FromArgb(unchecked((int)0xFFB3E3FD)),
            Color.FromArgb(unchecked((int)0xFFC977DB)),
            Color.FromArgb(unchecked((int)0xFFC1A7BB)),
            Color.FromArgb(unchecked((int)0xFF9286CB)),
            Color.FromArgb(unchecked((int)0xFFA19B6A)),
            Color.FromArgb(unchecked((int)0xFF8FFED7)),
            Color.FromArgb(unchecked((int)0xFF6B1F17)),
            Color.FromArgb(unchecked((int)0xFFDF503A)),
            Color.FromArgb(unchecked((int)0xFF10DDD7)),
            Color.FromArgb(unchecked((int)0xFF9A8457)),
            Color.FromArgb(unchecked((int)0xFF60672F)),
            Color.FromArgb(unchecked((int)0xFF7D327D)),
            Color.FromArgb(unchecked((int)0xFFDD8782)),
            Color.FromArgb(unchecked((int)0xFF59AC42)),
            Color.FromArgb(unchecked((int)0xFF82FDB8)),
            Color.FromArgb(unchecked((int)0xFFFC8AE7)),
            Color.FromArgb(unchecked((int)0xFF909F6F)),
            Color.FromArgb(unchecked((int)0xFFB691AE)),
            Color.FromArgb(unchecked((int)0xFFB811CD)),
            Color.FromArgb(unchecked((int)0xFFBCB24E)),
            Color.FromArgb(unchecked((int)0xFFCB4BD9)),
            Color.FromArgb(unchecked((int)0xFF2B2304)),
            Color.FromArgb(unchecked((int)0xFFAA9501)),
            Color.FromArgb(unchecked((int)0xFF5D5096)),
            Color.FromArgb(unchecked((int)0xFF403221)),
            Color.FromArgb(unchecked((int)0xFFF9FAB4)),
            Color.FromArgb(unchecked((int)0xFF3990FC)),
            Color.FromArgb(unchecked((int)0xFF70DE7F)),
            Color.FromArgb(unchecked((int)0xFF95857F)),
            Color.FromArgb(unchecked((int)0xFF84A385)),
            Color.FromArgb(unchecked((int)0xFF50996F)),
            Color.FromArgb(unchecked((int)0xFF797B53)),
            Color.FromArgb(unchecked((int)0xFF7B6142)),
            Color.FromArgb(unchecked((int)0xFF81D5FE)),
            Color.FromArgb(unchecked((int)0xFF9CC428)),
            Color.FromArgb(unchecked((int)0xFF0B0438)),
            Color.FromArgb(unchecked((int)0xFF3E2005)),
            Color.FromArgb(unchecked((int)0xFF4B7C91)),
            Color.FromArgb(unchecked((int)0xFF523854)),
            Color.FromArgb(unchecked((int)0xFF005EA9)),
            Color.FromArgb(unchecked((int)0xFFF0C7AD)),
            Color.FromArgb(unchecked((int)0xFFACB799)),
            Color.FromArgb(unchecked((int)0xFFFAC08E)),
            Color.FromArgb(unchecked((int)0xFF502239)),
            Color.FromArgb(unchecked((int)0xFFBFAB6A)),
            Color.FromArgb(unchecked((int)0xFF2B3C48)),
            Color.FromArgb(unchecked((int)0xFF0EB5D8)),
            Color.FromArgb(unchecked((int)0xFF8A5647)),
            Color.FromArgb(unchecked((int)0xFF49AF74)),
            Color.FromArgb(unchecked((int)0xFF067AE9)),
            Color.FromArgb(unchecked((int)0xFFF19509)),
            Color.FromArgb(unchecked((int)0xFF554628)),
            Color.FromArgb(unchecked((int)0xFF4426A4)),
            Color.FromArgb(unchecked((int)0xFF7352C9)),
            Color.FromArgb(unchecked((int)0xFF3F4287)),
            Color.FromArgb(unchecked((int)0xFF8B655E)),
            Color.FromArgb(unchecked((int)0xFFB480BF)),
            Color.FromArgb(unchecked((int)0xFF9BA74C)),
            Color.FromArgb(unchecked((int)0xFF5F514C)),
            Color.FromArgb(unchecked((int)0xFFCC9BDC)),
            Color.FromArgb(unchecked((int)0xFFBA7942)),
            Color.FromArgb(unchecked((int)0xFF1C4138)),
            Color.FromArgb(unchecked((int)0xFF3C3C3A)),
            Color.FromArgb(unchecked((int)0xFF29B09C)),
            Color.FromArgb(unchecked((int)0xFF02923F)),
            Color.FromArgb(unchecked((int)0xFF701D2B)),
            Color.FromArgb(unchecked((int)0xFF36577C)),
            Color.FromArgb(unchecked((int)0xFF3F00EA)),
            Color.FromArgb(unchecked((int)0xFF3D959E)),
            Color.FromArgb(unchecked((int)0xFF440601)),
            Color.FromArgb(unchecked((int)0xFF8AEFF3)),
            Color.FromArgb(unchecked((int)0xFF6D442A)),
            Color.FromArgb(unchecked((int)0xFFBEB1A8)),
            Color.FromArgb(unchecked((int)0xFFA11C02)),
            Color.FromArgb(unchecked((int)0xFF8383FE)),
            Color.FromArgb(unchecked((int)0xFFA73839)),
            Color.FromArgb(unchecked((int)0xFFDBDE8A)),
            Color.FromArgb(unchecked((int)0xFF0283B3)),
            Color.FromArgb(unchecked((int)0xFF888597)),
            Color.FromArgb(unchecked((int)0xFF32592E)),
            Color.FromArgb(unchecked((int)0xFFF5FDFA)),
            Color.FromArgb(unchecked((int)0xFF01191B)),
            Color.FromArgb(unchecked((int)0xFFAC707A)),
            Color.FromArgb(unchecked((int)0xFFB6BD03)),
            Color.FromArgb(unchecked((int)0xFF027B59)),
            Color.FromArgb(unchecked((int)0xFF7B4F08)),
            Color.FromArgb(unchecked((int)0xFF957737)),
            Color.FromArgb(unchecked((int)0xFF83727D)),
            Color.FromArgb(unchecked((int)0xFF035543)),
            Color.FromArgb(unchecked((int)0xFF6F7E64)),
            Color.FromArgb(unchecked((int)0xFFC39999)),
            Color.FromArgb(unchecked((int)0xFF52847A)),
            Color.FromArgb(unchecked((int)0xFF925AAC)),
            Color.FromArgb(unchecked((int)0xFF77CEDA)),
            Color.FromArgb(unchecked((int)0xFF516369)),
            Color.FromArgb(unchecked((int)0xFFE0D7D0)),
            Color.FromArgb(unchecked((int)0xFFFCDD97)),
            Color.FromArgb(unchecked((int)0xFF555424)),
            Color.FromArgb(unchecked((int)0xFF96E6B6)),
            Color.FromArgb(unchecked((int)0xFF85BB74)),
            Color.FromArgb(unchecked((int)0xFF5E2074)),
            Color.FromArgb(unchecked((int)0xFFBD5E48)),
            Color.FromArgb(unchecked((int)0xFF9BEE53)),
            Color.FromArgb(unchecked((int)0xFF1A351E)),
            Color.FromArgb(unchecked((int)0xFF3148CD)),
            Color.FromArgb(unchecked((int)0xFF71575F)),
            Color.FromArgb(unchecked((int)0xFF69A6D0)),
            Color.FromArgb(unchecked((int)0xFF391A62)),
            Color.FromArgb(unchecked((int)0xFFE79EA0)),
            Color.FromArgb(unchecked((int)0xFF1C0F03)),
            Color.FromArgb(unchecked((int)0xFF1B1636)),
            Color.FromArgb(unchecked((int)0xFFD20C39)),
            Color.FromArgb(unchecked((int)0xFF765396)),
            Color.FromArgb(unchecked((int)0xFF7402FE)),
            Color.FromArgb(unchecked((int)0xFF447F3E)),
            Color.FromArgb(unchecked((int)0xFFCFD0A8)),
            Color.FromArgb(unchecked((int)0xFF3A2600)),
            Color.FromArgb(unchecked((int)0xFF685AFC)),
            Color.FromArgb(unchecked((int)0xFFA4B3C6)),
            Color.FromArgb(unchecked((int)0xFF534302)),
            Color.FromArgb(unchecked((int)0xFF9AA097)),
            Color.FromArgb(unchecked((int)0xFFFD5154)),
            Color.FromArgb(unchecked((int)0xFF9B0085)),
            Color.FromArgb(unchecked((int)0xFF403956)),
            Color.FromArgb(unchecked((int)0xFF80A1A7)),
            Color.FromArgb(unchecked((int)0xFF6E7A9A)),
            Color.FromArgb(unchecked((int)0xFF605E6A)),
            Color.FromArgb(unchecked((int)0xFF86F0E2)),
            Color.FromArgb(unchecked((int)0xFF5A2B01)),
            Color.FromArgb(unchecked((int)0xFF7E3D43)),
            Color.FromArgb(unchecked((int)0xFFED823B)),
            Color.FromArgb(unchecked((int)0xFF32331B)),
            Color.FromArgb(unchecked((int)0xFF424837)),
            Color.FromArgb(unchecked((int)0xFF40755E)),
            Color.FromArgb(unchecked((int)0xFF524F48)),
            Color.FromArgb(unchecked((int)0xFFB75807)),
            Color.FromArgb(unchecked((int)0xFFB40080)),
            Color.FromArgb(unchecked((int)0xFF5B8CA1)),
            Color.FromArgb(unchecked((int)0xFFFDCFE5)),
            Color.FromArgb(unchecked((int)0xFFCCFEAC)),
            Color.FromArgb(unchecked((int)0xFF755847)),
            Color.FromArgb(unchecked((int)0xFFCAB296)),
            Color.FromArgb(unchecked((int)0xFFC0D6E3)),
            Color.FromArgb(unchecked((int)0xFF2D7100)),
            Color.FromArgb(unchecked((int)0xFFD5E4DE)),
            Color.FromArgb(unchecked((int)0xFF362823)),
            Color.FromArgb(unchecked((int)0xFF69C63C)),
            Color.FromArgb(unchecked((int)0xFFAC3801)),
            Color.FromArgb(unchecked((int)0xFF163132)),
            Color.FromArgb(unchecked((int)0xFF4750A6)),
            Color.FromArgb(unchecked((int)0xFF61B8B2)),
            Color.FromArgb(unchecked((int)0xFFFCC4B5)),
            Color.FromArgb(unchecked((int)0xFFDEBA2E)),
            Color.FromArgb(unchecked((int)0xFFFE0449)),
            Color.FromArgb(unchecked((int)0xFF737930)),
            Color.FromArgb(unchecked((int)0xFF8470AB)),
            Color.FromArgb(unchecked((int)0xFF687D87)),
            Color.FromArgb(unchecked((int)0xFFD7B760)),
            Color.FromArgb(unchecked((int)0xFF6AAB86)),
            Color.FromArgb(unchecked((int)0xFF8398B8)),
            Color.FromArgb(unchecked((int)0xFFB7B6BF)),
            Color.FromArgb(unchecked((int)0xFF92C4A1)),
            Color.FromArgb(unchecked((int)0xFFB6084F)),
            Color.FromArgb(unchecked((int)0xFF853B5E)),
            Color.FromArgb(unchecked((int)0xFFD0BCBA)),
            Color.FromArgb(unchecked((int)0xFF92826D)),
            Color.FromArgb(unchecked((int)0xFFC6DDC6)),
            Color.FromArgb(unchecked((int)0xFFBE5F5A)),
            Color.FromArgb(unchecked((int)0xFF280021)),
            Color.FromArgb(unchecked((int)0xFF435743)),
            Color.FromArgb(unchecked((int)0xFF874514)),
            Color.FromArgb(unchecked((int)0xFF63675A)),
            Color.FromArgb(unchecked((int)0xFFE97963)),
            Color.FromArgb(unchecked((int)0xFF8F9C9E)),
            Color.FromArgb(unchecked((int)0xFF985262)),
            Color.FromArgb(unchecked((int)0xFF909081)),
            Color.FromArgb(unchecked((int)0xFF023508)),
            Color.FromArgb(unchecked((int)0xFFDDADBF)),
            Color.FromArgb(unchecked((int)0xFFD78493)),
            Color.FromArgb(unchecked((int)0xFF363900)),
            Color.FromArgb(unchecked((int)0xFF5B0120)),
            Color.FromArgb(unchecked((int)0xFF603C47)),
            Color.FromArgb(unchecked((int)0xFFC3955D)),
            Color.FromArgb(unchecked((int)0xFFAC61CB)),
            Color.FromArgb(unchecked((int)0xFFFD7BA7)),
            Color.FromArgb(unchecked((int)0xFF716C74)),
            Color.FromArgb(unchecked((int)0xFF8D895B)),
            Color.FromArgb(unchecked((int)0xFF071001)),
            Color.FromArgb(unchecked((int)0xFF82B4F2)),
            Color.FromArgb(unchecked((int)0xFFB6BBD8)),
            Color.FromArgb(unchecked((int)0xFF71887A)),
            Color.FromArgb(unchecked((int)0xFF8B9FE3)),
            Color.FromArgb(unchecked((int)0xFF997158)),
            Color.FromArgb(unchecked((int)0xFF65A6AB)),
            Color.FromArgb(unchecked((int)0xFF2E3067)),
            Color.FromArgb(unchecked((int)0xFF321301)),
            Color.FromArgb(unchecked((int)0xFFFEECCB)),
            Color.FromArgb(unchecked((int)0xFF3B5E72)),
            Color.FromArgb(unchecked((int)0xFFC8FE85)),
            Color.FromArgb(unchecked((int)0xFFA1DCDF)),
            Color.FromArgb(unchecked((int)0xFFCB49A6)),
            Color.FromArgb(unchecked((int)0xFFB1C5E4)),
            Color.FromArgb(unchecked((int)0xFF3E5EB0)),
            Color.FromArgb(unchecked((int)0xFF88AEA7)),
            Color.FromArgb(unchecked((int)0xFF04504C)),
            Color.FromArgb(unchecked((int)0xFF975232)),
            Color.FromArgb(unchecked((int)0xFF6786B9)),
            Color.FromArgb(unchecked((int)0xFF068797)),
            Color.FromArgb(unchecked((int)0xFF9A98C4)),
            Color.FromArgb(unchecked((int)0xFFA1C3C2)),
            Color.FromArgb(unchecked((int)0xFF1C3967)),
            Color.FromArgb(unchecked((int)0xFFDBEA07)),
            Color.FromArgb(unchecked((int)0xFF789658)),
            Color.FromArgb(unchecked((int)0xFFE7E7C6)),
            Color.FromArgb(unchecked((int)0xFFA6C886)),
            Color.FromArgb(unchecked((int)0xFF957F89)),
            Color.FromArgb(unchecked((int)0xFF752E62)),
            Color.FromArgb(unchecked((int)0xFF171518)),
            Color.FromArgb(unchecked((int)0xFFA75648)),
            Color.FromArgb(unchecked((int)0xFF01D26F)),
            Color.FromArgb(unchecked((int)0xFF0F535D)),
            Color.FromArgb(unchecked((int)0xFF047E76)),
            Color.FromArgb(unchecked((int)0xFFC54754)),
            Color.FromArgb(unchecked((int)0xFF5D6E88)),
            Color.FromArgb(unchecked((int)0xFFAB9483)),
            Color.FromArgb(unchecked((int)0xFF803B99)),
            Color.FromArgb(unchecked((int)0xFFFA9C48)),
            Color.FromArgb(unchecked((int)0xFF4A8A22)),
            Color.FromArgb(unchecked((int)0xFF654A5C)),
            Color.FromArgb(unchecked((int)0xFF965F86)),
            Color.FromArgb(unchecked((int)0xFF9D0CBB)),
            Color.FromArgb(unchecked((int)0xFFA0E8A0)),
            Color.FromArgb(unchecked((int)0xFFD3DBFA)),
            Color.FromArgb(unchecked((int)0xFFFD908F)),
            Color.FromArgb(unchecked((int)0xFFAEAB85)),
            Color.FromArgb(unchecked((int)0xFFA13B89)),
            Color.FromArgb(unchecked((int)0xFFF1B350)),
            Color.FromArgb(unchecked((int)0xFF066898)),
            Color.FromArgb(unchecked((int)0xFF948A42)),
            Color.FromArgb(unchecked((int)0xFFC8BEDE)),
            Color.FromArgb(unchecked((int)0xFF19252C)),
            Color.FromArgb(unchecked((int)0xFF7046AA)),
            Color.FromArgb(unchecked((int)0xFFE1EEFC)),
            Color.FromArgb(unchecked((int)0xFF3E6557)),
            Color.FromArgb(unchecked((int)0xFFCD3F26)),
            Color.FromArgb(unchecked((int)0xFF2B1925)),
            Color.FromArgb(unchecked((int)0xFFDDAD94)),
            Color.FromArgb(unchecked((int)0xFFC0B109)),
            Color.FromArgb(unchecked((int)0xFF37DFFE)),
            Color.FromArgb(unchecked((int)0xFF039676)),
            Color.FromArgb(unchecked((int)0xFF907468)),
            Color.FromArgb(unchecked((int)0xFF9E86A5)),
            Color.FromArgb(unchecked((int)0xFF3A1B49)),
            Color.FromArgb(unchecked((int)0xFFBEE5B7)),
            Color.FromArgb(unchecked((int)0xFFC29501)),
            Color.FromArgb(unchecked((int)0xFF9E3645)),
            Color.FromArgb(unchecked((int)0xFFDC580A)),
            Color.FromArgb(unchecked((int)0xFF645631)),
            Color.FromArgb(unchecked((int)0xFF444B4B)),
            Color.FromArgb(unchecked((int)0xFFFD1A63)),
            Color.FromArgb(unchecked((int)0xFFDDE5AE)),
            Color.FromArgb(unchecked((int)0xFF887800)),
            Color.FromArgb(unchecked((int)0xFF36006F)),
            Color.FromArgb(unchecked((int)0xFF3A6260)),
            Color.FromArgb(unchecked((int)0xFF784637)),
            Color.FromArgb(unchecked((int)0xFFFEA0B7)),
            Color.FromArgb(unchecked((int)0xFFA3E0D2)),
            Color.FromArgb(unchecked((int)0xFF6D6316)),
            Color.FromArgb(unchecked((int)0xFF5F7172)),
            Color.FromArgb(unchecked((int)0xFFB99EC7)),
            Color.FromArgb(unchecked((int)0xFF777A7E)),
            Color.FromArgb(unchecked((int)0xFFE0FEFD)),
            Color.FromArgb(unchecked((int)0xFFE16DC5)),
            Color.FromArgb(unchecked((int)0xFF01344B)),
            Color.FromArgb(unchecked((int)0xFFF8F8FC)),
            Color.FromArgb(unchecked((int)0xFF9F9FB5)),
            Color.FromArgb(unchecked((int)0xFF182617)),
            Color.FromArgb(unchecked((int)0xFFFE3D21)),
            Color.FromArgb(unchecked((int)0xFF7D0017)),
            Color.FromArgb(unchecked((int)0xFF822F21)),
            Color.FromArgb(unchecked((int)0xFFEFD9DC)),
            Color.FromArgb(unchecked((int)0xFF6E68C4)),
            Color.FromArgb(unchecked((int)0xFF35473E)),
            Color.FromArgb(unchecked((int)0xFF007523)),
            Color.FromArgb(unchecked((int)0xFF767667)),
            Color.FromArgb(unchecked((int)0xFFA6825D)),
            Color.FromArgb(unchecked((int)0xFF83DC5F)),
            Color.FromArgb(unchecked((int)0xFF227285)),
            Color.FromArgb(unchecked((int)0xFFA95E34)),
            Color.FromArgb(unchecked((int)0xFF526172)),
            Color.FromArgb(unchecked((int)0xFF979730)),
            Color.FromArgb(unchecked((int)0xFF756F6D)),
            Color.FromArgb(unchecked((int)0xFF716259)),
            Color.FromArgb(unchecked((int)0xFFE8B2B5)),
            Color.FromArgb(unchecked((int)0xFFB6C9BB)),
            Color.FromArgb(unchecked((int)0xFF9078DA)),
            Color.FromArgb(unchecked((int)0xFF4F326E)),
            Color.FromArgb(unchecked((int)0xFFB2387B)),
            Color.FromArgb(unchecked((int)0xFF888C6F)),
            Color.FromArgb(unchecked((int)0xFF314B5F)),
            Color.FromArgb(unchecked((int)0xFFE5B678)),
            Color.FromArgb(unchecked((int)0xFF38A3C6)),
            Color.FromArgb(unchecked((int)0xFF586148)),
            Color.FromArgb(unchecked((int)0xFF5C515B)),
            Color.FromArgb(unchecked((int)0xFFCDCCE1)),
            Color.FromArgb(unchecked((int)0xFFC8977F)),
        };

        // From 1024 colors array here : https://stackoverflow.com/a/12224359/294998
        // generated with CIELab Delta2000 / Starting with black
        // Tips: skip the first 2 colors
        public static readonly Color[] DistinctColors1024 = new Color[]
        {
            Color.FromArgb(unchecked((int)0xFF000000)), Color.FromArgb(unchecked((int)0xFFFFFF00)), Color.FromArgb(unchecked((int)0xFF1CE6FF)), Color.FromArgb(unchecked((int)0xFFFF34FF)), Color.FromArgb(unchecked((int)0xFFFF4A46)), Color.FromArgb(unchecked((int)0xFF008941)), Color.FromArgb(unchecked((int)0xFF006FA6)), Color.FromArgb(unchecked((int)0xFFA30059)),
            Color.FromArgb(unchecked((int)0xFFFFDBE5)), Color.FromArgb(unchecked((int)0xFF7A4900)), Color.FromArgb(unchecked((int)0xFF0000A6)), Color.FromArgb(unchecked((int)0xFF63FFAC)), Color.FromArgb(unchecked((int)0xFFB79762)), Color.FromArgb(unchecked((int)0xFF004D43)), Color.FromArgb(unchecked((int)0xFF8FB0FF)), Color.FromArgb(unchecked((int)0xFF997D87)),
            Color.FromArgb(unchecked((int)0xFF5A0007)), Color.FromArgb(unchecked((int)0xFF809693)), Color.FromArgb(unchecked((int)0xFFFEFFE6)), Color.FromArgb(unchecked((int)0xFF1B4400)), Color.FromArgb(unchecked((int)0xFF4FC601)), Color.FromArgb(unchecked((int)0xFF3B5DFF)), Color.FromArgb(unchecked((int)0xFF4A3B53)), Color.FromArgb(unchecked((int)0xFFFF2F80)),
            Color.FromArgb(unchecked((int)0xFF61615A)), Color.FromArgb(unchecked((int)0xFFBA0900)), Color.FromArgb(unchecked((int)0xFF6B7900)), Color.FromArgb(unchecked((int)0xFF00C2A0)), Color.FromArgb(unchecked((int)0xFFFFAA92)), Color.FromArgb(unchecked((int)0xFFFF90C9)), Color.FromArgb(unchecked((int)0xFFB903AA)), Color.FromArgb(unchecked((int)0xFFD16100)),
            Color.FromArgb(unchecked((int)0xFFDDEFFF)), Color.FromArgb(unchecked((int)0xFF000035)), Color.FromArgb(unchecked((int)0xFF7B4F4B)), Color.FromArgb(unchecked((int)0xFFA1C299)), Color.FromArgb(unchecked((int)0xFF300018)), Color.FromArgb(unchecked((int)0xFF0AA6D8)), Color.FromArgb(unchecked((int)0xFF013349)), Color.FromArgb(unchecked((int)0xFF00846F)),
            Color.FromArgb(unchecked((int)0xFF372101)), Color.FromArgb(unchecked((int)0xFFFFB500)), Color.FromArgb(unchecked((int)0xFFC2FFED)), Color.FromArgb(unchecked((int)0xFFA079BF)), Color.FromArgb(unchecked((int)0xFFCC0744)), Color.FromArgb(unchecked((int)0xFFC0B9B2)), Color.FromArgb(unchecked((int)0xFFC2FF99)), Color.FromArgb(unchecked((int)0xFF001E09)),
            Color.FromArgb(unchecked((int)0xFF00489C)), Color.FromArgb(unchecked((int)0xFF6F0062)), Color.FromArgb(unchecked((int)0xFF0CBD66)), Color.FromArgb(unchecked((int)0xFFEEC3FF)), Color.FromArgb(unchecked((int)0xFF456D75)), Color.FromArgb(unchecked((int)0xFFB77B68)), Color.FromArgb(unchecked((int)0xFF7A87A1)), Color.FromArgb(unchecked((int)0xFF788D66)),
            Color.FromArgb(unchecked((int)0xFF885578)), Color.FromArgb(unchecked((int)0xFFFAD09F)), Color.FromArgb(unchecked((int)0xFFFF8A9A)), Color.FromArgb(unchecked((int)0xFFD157A0)), Color.FromArgb(unchecked((int)0xFFBEC459)), Color.FromArgb(unchecked((int)0xFF456648)), Color.FromArgb(unchecked((int)0xFF0086ED)), Color.FromArgb(unchecked((int)0xFF886F4C)),
            Color.FromArgb(unchecked((int)0xFF34362D)), Color.FromArgb(unchecked((int)0xFFB4A8BD)), Color.FromArgb(unchecked((int)0xFF00A6AA)), Color.FromArgb(unchecked((int)0xFF452C2C)), Color.FromArgb(unchecked((int)0xFF636375)), Color.FromArgb(unchecked((int)0xFFA3C8C9)), Color.FromArgb(unchecked((int)0xFFFF913F)), Color.FromArgb(unchecked((int)0xFF938A81)),
            Color.FromArgb(unchecked((int)0xFF575329)), Color.FromArgb(unchecked((int)0xFF00FECF)), Color.FromArgb(unchecked((int)0xFFB05B6F)), Color.FromArgb(unchecked((int)0xFF8CD0FF)), Color.FromArgb(unchecked((int)0xFF3B9700)), Color.FromArgb(unchecked((int)0xFF04F757)), Color.FromArgb(unchecked((int)0xFFC8A1A1)), Color.FromArgb(unchecked((int)0xFF1E6E00)),
            Color.FromArgb(unchecked((int)0xFF7900D7)), Color.FromArgb(unchecked((int)0xFFA77500)), Color.FromArgb(unchecked((int)0xFF6367A9)), Color.FromArgb(unchecked((int)0xFFA05837)), Color.FromArgb(unchecked((int)0xFF6B002C)), Color.FromArgb(unchecked((int)0xFF772600)), Color.FromArgb(unchecked((int)0xFFD790FF)), Color.FromArgb(unchecked((int)0xFF9B9700)),
            Color.FromArgb(unchecked((int)0xFF549E79)), Color.FromArgb(unchecked((int)0xFFFFF69F)), Color.FromArgb(unchecked((int)0xFF201625)), Color.FromArgb(unchecked((int)0xFF72418F)), Color.FromArgb(unchecked((int)0xFFBC23FF)), Color.FromArgb(unchecked((int)0xFF99ADC0)), Color.FromArgb(unchecked((int)0xFF3A2465)), Color.FromArgb(unchecked((int)0xFF922329)),
            Color.FromArgb(unchecked((int)0xFF5B4534)), Color.FromArgb(unchecked((int)0xFFFDE8DC)), Color.FromArgb(unchecked((int)0xFF404E55)), Color.FromArgb(unchecked((int)0xFF0089A3)), Color.FromArgb(unchecked((int)0xFFCB7E98)), Color.FromArgb(unchecked((int)0xFFA4E804)), Color.FromArgb(unchecked((int)0xFF324E72)), Color.FromArgb(unchecked((int)0xFF6A3A4C)),
            Color.FromArgb(unchecked((int)0xFF83AB58)), Color.FromArgb(unchecked((int)0xFF001C1E)), Color.FromArgb(unchecked((int)0xFFD1F7CE)), Color.FromArgb(unchecked((int)0xFF004B28)), Color.FromArgb(unchecked((int)0xFFC8D0F6)), Color.FromArgb(unchecked((int)0xFFA3A489)), Color.FromArgb(unchecked((int)0xFF806C66)), Color.FromArgb(unchecked((int)0xFF222800)),
            Color.FromArgb(unchecked((int)0xFFBF5650)), Color.FromArgb(unchecked((int)0xFFE83000)), Color.FromArgb(unchecked((int)0xFF66796D)), Color.FromArgb(unchecked((int)0xFFDA007C)), Color.FromArgb(unchecked((int)0xFFFF1A59)), Color.FromArgb(unchecked((int)0xFF8ADBB4)), Color.FromArgb(unchecked((int)0xFF1E0200)), Color.FromArgb(unchecked((int)0xFF5B4E51)),
            Color.FromArgb(unchecked((int)0xFFC895C5)), Color.FromArgb(unchecked((int)0xFF320033)), Color.FromArgb(unchecked((int)0xFFFF6832)), Color.FromArgb(unchecked((int)0xFF66E1D3)), Color.FromArgb(unchecked((int)0xFFCFCDAC)), Color.FromArgb(unchecked((int)0xFFD0AC94)), Color.FromArgb(unchecked((int)0xFF7ED379)), Color.FromArgb(unchecked((int)0xFF012C58)),
            Color.FromArgb(unchecked((int)0xFF7A7BFF)), Color.FromArgb(unchecked((int)0xFFD68E01)), Color.FromArgb(unchecked((int)0xFF353339)), Color.FromArgb(unchecked((int)0xFF78AFA1)), Color.FromArgb(unchecked((int)0xFFFEB2C6)), Color.FromArgb(unchecked((int)0xFF75797C)), Color.FromArgb(unchecked((int)0xFF837393)), Color.FromArgb(unchecked((int)0xFF943A4D)),
            Color.FromArgb(unchecked((int)0xFFB5F4FF)), Color.FromArgb(unchecked((int)0xFFD2DCD5)), Color.FromArgb(unchecked((int)0xFF9556BD)), Color.FromArgb(unchecked((int)0xFF6A714A)), Color.FromArgb(unchecked((int)0xFF001325)), Color.FromArgb(unchecked((int)0xFF02525F)), Color.FromArgb(unchecked((int)0xFF0AA3F7)), Color.FromArgb(unchecked((int)0xFFE98176)),
            Color.FromArgb(unchecked((int)0xFFDBD5DD)), Color.FromArgb(unchecked((int)0xFF5EBCD1)), Color.FromArgb(unchecked((int)0xFF3D4F44)), Color.FromArgb(unchecked((int)0xFF7E6405)), Color.FromArgb(unchecked((int)0xFF02684E)), Color.FromArgb(unchecked((int)0xFF962B75)), Color.FromArgb(unchecked((int)0xFF8D8546)), Color.FromArgb(unchecked((int)0xFF9695C5)),
            Color.FromArgb(unchecked((int)0xFFE773CE)), Color.FromArgb(unchecked((int)0xFFD86A78)), Color.FromArgb(unchecked((int)0xFF3E89BE)), Color.FromArgb(unchecked((int)0xFFCA834E)), Color.FromArgb(unchecked((int)0xFF518A87)), Color.FromArgb(unchecked((int)0xFF5B113C)), Color.FromArgb(unchecked((int)0xFF55813B)), Color.FromArgb(unchecked((int)0xFFE704C4)),
            Color.FromArgb(unchecked((int)0xFF00005F)), Color.FromArgb(unchecked((int)0xFFA97399)), Color.FromArgb(unchecked((int)0xFF4B8160)), Color.FromArgb(unchecked((int)0xFF59738A)), Color.FromArgb(unchecked((int)0xFFFF5DA7)), Color.FromArgb(unchecked((int)0xFFF7C9BF)), Color.FromArgb(unchecked((int)0xFF643127)), Color.FromArgb(unchecked((int)0xFF513A01)),
            Color.FromArgb(unchecked((int)0xFF6B94AA)), Color.FromArgb(unchecked((int)0xFF51A058)), Color.FromArgb(unchecked((int)0xFFA45B02)), Color.FromArgb(unchecked((int)0xFF1D1702)), Color.FromArgb(unchecked((int)0xFFE20027)), Color.FromArgb(unchecked((int)0xFFE7AB63)), Color.FromArgb(unchecked((int)0xFF4C6001)), Color.FromArgb(unchecked((int)0xFF9C6966)),
            Color.FromArgb(unchecked((int)0xFF64547B)), Color.FromArgb(unchecked((int)0xFF97979E)), Color.FromArgb(unchecked((int)0xFF006A66)), Color.FromArgb(unchecked((int)0xFF391406)), Color.FromArgb(unchecked((int)0xFFF4D749)), Color.FromArgb(unchecked((int)0xFF0045D2)), Color.FromArgb(unchecked((int)0xFF006C31)), Color.FromArgb(unchecked((int)0xFFDDB6D0)),
            Color.FromArgb(unchecked((int)0xFF7C6571)), Color.FromArgb(unchecked((int)0xFF9FB2A4)), Color.FromArgb(unchecked((int)0xFF00D891)), Color.FromArgb(unchecked((int)0xFF15A08A)), Color.FromArgb(unchecked((int)0xFFBC65E9)), Color.FromArgb(unchecked((int)0xFFFFFFFE)), Color.FromArgb(unchecked((int)0xFFC6DC99)), Color.FromArgb(unchecked((int)0xFF203B3C)),
            Color.FromArgb(unchecked((int)0xFF671190)), Color.FromArgb(unchecked((int)0xFF6B3A64)), Color.FromArgb(unchecked((int)0xFFF5E1FF)), Color.FromArgb(unchecked((int)0xFFFFA0F2)), Color.FromArgb(unchecked((int)0xFFCCAA35)), Color.FromArgb(unchecked((int)0xFF374527)), Color.FromArgb(unchecked((int)0xFF8BB400)), Color.FromArgb(unchecked((int)0xFF797868)),
            Color.FromArgb(unchecked((int)0xFFC6005A)), Color.FromArgb(unchecked((int)0xFF3B000A)), Color.FromArgb(unchecked((int)0xFFC86240)), Color.FromArgb(unchecked((int)0xFF29607C)), Color.FromArgb(unchecked((int)0xFF402334)), Color.FromArgb(unchecked((int)0xFF7D5A44)), Color.FromArgb(unchecked((int)0xFFCCB87C)), Color.FromArgb(unchecked((int)0xFFB88183)),
            Color.FromArgb(unchecked((int)0xFFAA5199)), Color.FromArgb(unchecked((int)0xFFB5D6C3)), Color.FromArgb(unchecked((int)0xFFA38469)), Color.FromArgb(unchecked((int)0xFF9F94F0)), Color.FromArgb(unchecked((int)0xFFA74571)), Color.FromArgb(unchecked((int)0xFFB894A6)), Color.FromArgb(unchecked((int)0xFF71BB8C)), Color.FromArgb(unchecked((int)0xFF00B433)),
            Color.FromArgb(unchecked((int)0xFF789EC9)), Color.FromArgb(unchecked((int)0xFF6D80BA)), Color.FromArgb(unchecked((int)0xFF953F00)), Color.FromArgb(unchecked((int)0xFF5EFF03)), Color.FromArgb(unchecked((int)0xFFE4FFFC)), Color.FromArgb(unchecked((int)0xFF1BE177)), Color.FromArgb(unchecked((int)0xFFBCB1E5)), Color.FromArgb(unchecked((int)0xFF76912F)),
            Color.FromArgb(unchecked((int)0xFF003109)), Color.FromArgb(unchecked((int)0xFF0060CD)), Color.FromArgb(unchecked((int)0xFFD20096)), Color.FromArgb(unchecked((int)0xFF895563)), Color.FromArgb(unchecked((int)0xFF29201D)), Color.FromArgb(unchecked((int)0xFF5B3213)), Color.FromArgb(unchecked((int)0xFFA76F42)), Color.FromArgb(unchecked((int)0xFF89412E)),
            Color.FromArgb(unchecked((int)0xFF1A3A2A)), Color.FromArgb(unchecked((int)0xFF494B5A)), Color.FromArgb(unchecked((int)0xFFA88C85)), Color.FromArgb(unchecked((int)0xFFF4ABAA)), Color.FromArgb(unchecked((int)0xFFA3F3AB)), Color.FromArgb(unchecked((int)0xFF00C6C8)), Color.FromArgb(unchecked((int)0xFFEA8B66)), Color.FromArgb(unchecked((int)0xFF958A9F)),
            Color.FromArgb(unchecked((int)0xFFBDC9D2)), Color.FromArgb(unchecked((int)0xFF9FA064)), Color.FromArgb(unchecked((int)0xFFBE4700)), Color.FromArgb(unchecked((int)0xFF658188)), Color.FromArgb(unchecked((int)0xFF83A485)), Color.FromArgb(unchecked((int)0xFF453C23)), Color.FromArgb(unchecked((int)0xFF47675D)), Color.FromArgb(unchecked((int)0xFF3A3F00)),
            Color.FromArgb(unchecked((int)0xFF061203)), Color.FromArgb(unchecked((int)0xFFDFFB71)), Color.FromArgb(unchecked((int)0xFF868E7E)), Color.FromArgb(unchecked((int)0xFF98D058)), Color.FromArgb(unchecked((int)0xFF6C8F7D)), Color.FromArgb(unchecked((int)0xFFD7BFC2)), Color.FromArgb(unchecked((int)0xFF3C3E6E)), Color.FromArgb(unchecked((int)0xFFD83D66)),
            Color.FromArgb(unchecked((int)0xFF2F5D9B)), Color.FromArgb(unchecked((int)0xFF6C5E46)), Color.FromArgb(unchecked((int)0xFFD25B88)), Color.FromArgb(unchecked((int)0xFF5B656C)), Color.FromArgb(unchecked((int)0xFF00B57F)), Color.FromArgb(unchecked((int)0xFF545C46)), Color.FromArgb(unchecked((int)0xFF866097)), Color.FromArgb(unchecked((int)0xFF365D25)),
            Color.FromArgb(unchecked((int)0xFF252F99)), Color.FromArgb(unchecked((int)0xFF00CCFF)), Color.FromArgb(unchecked((int)0xFF674E60)), Color.FromArgb(unchecked((int)0xFFFC009C)), Color.FromArgb(unchecked((int)0xFF92896B)), Color.FromArgb(unchecked((int)0xFF1E2324)), Color.FromArgb(unchecked((int)0xFFDEC9B2)), Color.FromArgb(unchecked((int)0xFF9D4948)),
            Color.FromArgb(unchecked((int)0xFF85ABB4)), Color.FromArgb(unchecked((int)0xFF342142)), Color.FromArgb(unchecked((int)0xFFD09685)), Color.FromArgb(unchecked((int)0xFFA4ACAC)), Color.FromArgb(unchecked((int)0xFF00FFFF)), Color.FromArgb(unchecked((int)0xFFAE9C86)), Color.FromArgb(unchecked((int)0xFF742A33)), Color.FromArgb(unchecked((int)0xFF0E72C5)),
            Color.FromArgb(unchecked((int)0xFFAFD8EC)), Color.FromArgb(unchecked((int)0xFFC064B9)), Color.FromArgb(unchecked((int)0xFF91028C)), Color.FromArgb(unchecked((int)0xFFFEEDBF)), Color.FromArgb(unchecked((int)0xFFFFB789)), Color.FromArgb(unchecked((int)0xFF9CB8E4)), Color.FromArgb(unchecked((int)0xFFAFFFD1)), Color.FromArgb(unchecked((int)0xFF2A364C)),
            Color.FromArgb(unchecked((int)0xFF4F4A43)), Color.FromArgb(unchecked((int)0xFF647095)), Color.FromArgb(unchecked((int)0xFF34BBFF)), Color.FromArgb(unchecked((int)0xFF807781)), Color.FromArgb(unchecked((int)0xFF920003)), Color.FromArgb(unchecked((int)0xFFB3A5A7)), Color.FromArgb(unchecked((int)0xFF018615)), Color.FromArgb(unchecked((int)0xFFF1FFC8)),
            Color.FromArgb(unchecked((int)0xFF976F5C)), Color.FromArgb(unchecked((int)0xFFFF3BC1)), Color.FromArgb(unchecked((int)0xFFFF5F6B)), Color.FromArgb(unchecked((int)0xFF077D84)), Color.FromArgb(unchecked((int)0xFFF56D93)), Color.FromArgb(unchecked((int)0xFF5771DA)), Color.FromArgb(unchecked((int)0xFF4E1E2A)), Color.FromArgb(unchecked((int)0xFF830055)),
            Color.FromArgb(unchecked((int)0xFF02D346)), Color.FromArgb(unchecked((int)0xFFBE452D)), Color.FromArgb(unchecked((int)0xFF00905E)), Color.FromArgb(unchecked((int)0xFFBE0028)), Color.FromArgb(unchecked((int)0xFF6E96E3)), Color.FromArgb(unchecked((int)0xFF007699)), Color.FromArgb(unchecked((int)0xFFFEC96D)), Color.FromArgb(unchecked((int)0xFF9C6A7D)),
            Color.FromArgb(unchecked((int)0xFF3FA1B8)), Color.FromArgb(unchecked((int)0xFF893DE3)), Color.FromArgb(unchecked((int)0xFF79B4D6)), Color.FromArgb(unchecked((int)0xFF7FD4D9)), Color.FromArgb(unchecked((int)0xFF6751BB)), Color.FromArgb(unchecked((int)0xFFB28D2D)), Color.FromArgb(unchecked((int)0xFFE27A05)), Color.FromArgb(unchecked((int)0xFFDD9CB8)),
            Color.FromArgb(unchecked((int)0xFFAABC7A)), Color.FromArgb(unchecked((int)0xFF980034)), Color.FromArgb(unchecked((int)0xFF561A02)), Color.FromArgb(unchecked((int)0xFF8F7F00)), Color.FromArgb(unchecked((int)0xFF635000)), Color.FromArgb(unchecked((int)0xFFCD7DAE)), Color.FromArgb(unchecked((int)0xFF8A5E2D)), Color.FromArgb(unchecked((int)0xFFFFB3E1)),
            Color.FromArgb(unchecked((int)0xFF6B6466)), Color.FromArgb(unchecked((int)0xFFC6D300)), Color.FromArgb(unchecked((int)0xFF0100E2)), Color.FromArgb(unchecked((int)0xFF88EC69)), Color.FromArgb(unchecked((int)0xFF8FCCBE)), Color.FromArgb(unchecked((int)0xFF21001C)), Color.FromArgb(unchecked((int)0xFF511F4D)), Color.FromArgb(unchecked((int)0xFFE3F6E3)),
            Color.FromArgb(unchecked((int)0xFFFF8EB1)), Color.FromArgb(unchecked((int)0xFF6B4F29)), Color.FromArgb(unchecked((int)0xFFA37F46)), Color.FromArgb(unchecked((int)0xFF6A5950)), Color.FromArgb(unchecked((int)0xFF1F2A1A)), Color.FromArgb(unchecked((int)0xFF04784D)), Color.FromArgb(unchecked((int)0xFF101835)), Color.FromArgb(unchecked((int)0xFFE6E0D0)),
            Color.FromArgb(unchecked((int)0xFFFF74FE)), Color.FromArgb(unchecked((int)0xFF00A45F)), Color.FromArgb(unchecked((int)0xFF8F5DF8)), Color.FromArgb(unchecked((int)0xFF4B0059)), Color.FromArgb(unchecked((int)0xFF412F23)), Color.FromArgb(unchecked((int)0xFFD8939E)), Color.FromArgb(unchecked((int)0xFFDB9D72)), Color.FromArgb(unchecked((int)0xFF604143)),
            Color.FromArgb(unchecked((int)0xFFB5BACE)), Color.FromArgb(unchecked((int)0xFF989EB7)), Color.FromArgb(unchecked((int)0xFFD2C4DB)), Color.FromArgb(unchecked((int)0xFFA587AF)), Color.FromArgb(unchecked((int)0xFF77D796)), Color.FromArgb(unchecked((int)0xFF7F8C94)), Color.FromArgb(unchecked((int)0xFFFF9B03)), Color.FromArgb(unchecked((int)0xFF555196)),
            Color.FromArgb(unchecked((int)0xFF31DDAE)), Color.FromArgb(unchecked((int)0xFF74B671)), Color.FromArgb(unchecked((int)0xFF802647)), Color.FromArgb(unchecked((int)0xFF2A373F)), Color.FromArgb(unchecked((int)0xFF014A68)), Color.FromArgb(unchecked((int)0xFF696628)), Color.FromArgb(unchecked((int)0xFF4C7B6D)), Color.FromArgb(unchecked((int)0xFF002C27)),
            Color.FromArgb(unchecked((int)0xFF7A4522)), Color.FromArgb(unchecked((int)0xFF3B5859)), Color.FromArgb(unchecked((int)0xFFE5D381)), Color.FromArgb(unchecked((int)0xFFFFF3FF)), Color.FromArgb(unchecked((int)0xFF679FA0)), Color.FromArgb(unchecked((int)0xFF261300)), Color.FromArgb(unchecked((int)0xFF2C5742)), Color.FromArgb(unchecked((int)0xFF9131AF)),
            Color.FromArgb(unchecked((int)0xFFAF5D88)), Color.FromArgb(unchecked((int)0xFFC7706A)), Color.FromArgb(unchecked((int)0xFF61AB1F)), Color.FromArgb(unchecked((int)0xFF8CF2D4)), Color.FromArgb(unchecked((int)0xFFC5D9B8)), Color.FromArgb(unchecked((int)0xFF9FFFFB)), Color.FromArgb(unchecked((int)0xFFBF45CC)), Color.FromArgb(unchecked((int)0xFF493941)),
            Color.FromArgb(unchecked((int)0xFF863B60)), Color.FromArgb(unchecked((int)0xFFB90076)), Color.FromArgb(unchecked((int)0xFF003177)), Color.FromArgb(unchecked((int)0xFFC582D2)), Color.FromArgb(unchecked((int)0xFFC1B394)), Color.FromArgb(unchecked((int)0xFF602B70)), Color.FromArgb(unchecked((int)0xFF887868)), Color.FromArgb(unchecked((int)0xFFBABFB0)),
            Color.FromArgb(unchecked((int)0xFF030012)), Color.FromArgb(unchecked((int)0xFFD1ACFE)), Color.FromArgb(unchecked((int)0xFF7FDEFE)), Color.FromArgb(unchecked((int)0xFF4B5C71)), Color.FromArgb(unchecked((int)0xFFA3A097)), Color.FromArgb(unchecked((int)0xFFE66D53)), Color.FromArgb(unchecked((int)0xFF637B5D)), Color.FromArgb(unchecked((int)0xFF92BEA5)),
            Color.FromArgb(unchecked((int)0xFF00F8B3)), Color.FromArgb(unchecked((int)0xFFBEDDFF)), Color.FromArgb(unchecked((int)0xFF3DB5A7)), Color.FromArgb(unchecked((int)0xFFDD3248)), Color.FromArgb(unchecked((int)0xFFB6E4DE)), Color.FromArgb(unchecked((int)0xFF427745)), Color.FromArgb(unchecked((int)0xFF598C5A)), Color.FromArgb(unchecked((int)0xFFB94C59)),
            Color.FromArgb(unchecked((int)0xFF8181D5)), Color.FromArgb(unchecked((int)0xFF94888B)), Color.FromArgb(unchecked((int)0xFFFED6BD)), Color.FromArgb(unchecked((int)0xFF536D31)), Color.FromArgb(unchecked((int)0xFF6EFF92)), Color.FromArgb(unchecked((int)0xFFE4E8FF)), Color.FromArgb(unchecked((int)0xFF20E200)), Color.FromArgb(unchecked((int)0xFFFFD0F2)),
            Color.FromArgb(unchecked((int)0xFF4C83A1)), Color.FromArgb(unchecked((int)0xFFBD7322)), Color.FromArgb(unchecked((int)0xFF915C4E)), Color.FromArgb(unchecked((int)0xFF8C4787)), Color.FromArgb(unchecked((int)0xFF025117)), Color.FromArgb(unchecked((int)0xFFA2AA45)), Color.FromArgb(unchecked((int)0xFF2D1B21)), Color.FromArgb(unchecked((int)0xFFA9DDB0)),
            Color.FromArgb(unchecked((int)0xFFFF4F78)), Color.FromArgb(unchecked((int)0xFF528500)), Color.FromArgb(unchecked((int)0xFF009A2E)), Color.FromArgb(unchecked((int)0xFF17FCE4)), Color.FromArgb(unchecked((int)0xFF71555A)), Color.FromArgb(unchecked((int)0xFF525D82)), Color.FromArgb(unchecked((int)0xFF00195A)), Color.FromArgb(unchecked((int)0xFF967874)),
            Color.FromArgb(unchecked((int)0xFF555558)), Color.FromArgb(unchecked((int)0xFF0B212C)), Color.FromArgb(unchecked((int)0xFF1E202B)), Color.FromArgb(unchecked((int)0xFFEFBFC4)), Color.FromArgb(unchecked((int)0xFF6F9755)), Color.FromArgb(unchecked((int)0xFF6F7586)), Color.FromArgb(unchecked((int)0xFF501D1D)), Color.FromArgb(unchecked((int)0xFF372D00)),
            Color.FromArgb(unchecked((int)0xFF741D16)), Color.FromArgb(unchecked((int)0xFF5EB393)), Color.FromArgb(unchecked((int)0xFFB5B400)), Color.FromArgb(unchecked((int)0xFFDD4A38)), Color.FromArgb(unchecked((int)0xFF363DFF)), Color.FromArgb(unchecked((int)0xFFAD6552)), Color.FromArgb(unchecked((int)0xFF6635AF)), Color.FromArgb(unchecked((int)0xFF836BBA)),
            Color.FromArgb(unchecked((int)0xFF98AA7F)), Color.FromArgb(unchecked((int)0xFF464836)), Color.FromArgb(unchecked((int)0xFF322C3E)), Color.FromArgb(unchecked((int)0xFF7CB9BA)), Color.FromArgb(unchecked((int)0xFF5B6965)), Color.FromArgb(unchecked((int)0xFF707D3D)), Color.FromArgb(unchecked((int)0xFF7A001D)), Color.FromArgb(unchecked((int)0xFF6E4636)),
            Color.FromArgb(unchecked((int)0xFF443A38)), Color.FromArgb(unchecked((int)0xFFAE81FF)), Color.FromArgb(unchecked((int)0xFF489079)), Color.FromArgb(unchecked((int)0xFF897334)), Color.FromArgb(unchecked((int)0xFF009087)), Color.FromArgb(unchecked((int)0xFFDA713C)), Color.FromArgb(unchecked((int)0xFF361618)), Color.FromArgb(unchecked((int)0xFFFF6F01)),
            Color.FromArgb(unchecked((int)0xFF006679)), Color.FromArgb(unchecked((int)0xFF370E77)), Color.FromArgb(unchecked((int)0xFF4B3A83)), Color.FromArgb(unchecked((int)0xFFC9E2E6)), Color.FromArgb(unchecked((int)0xFFC44170)), Color.FromArgb(unchecked((int)0xFFFF4526)), Color.FromArgb(unchecked((int)0xFF73BE54)), Color.FromArgb(unchecked((int)0xFFC4DF72)),
            Color.FromArgb(unchecked((int)0xFFADFF60)), Color.FromArgb(unchecked((int)0xFF00447D)), Color.FromArgb(unchecked((int)0xFFDCCEC9)), Color.FromArgb(unchecked((int)0xFFBD9479)), Color.FromArgb(unchecked((int)0xFF656E5B)), Color.FromArgb(unchecked((int)0xFFEC5200)), Color.FromArgb(unchecked((int)0xFFFF6EC2)), Color.FromArgb(unchecked((int)0xFF7A617E)),
            Color.FromArgb(unchecked((int)0xFFDDAEA2)), Color.FromArgb(unchecked((int)0xFF77837F)), Color.FromArgb(unchecked((int)0xFFA53327)), Color.FromArgb(unchecked((int)0xFF608EFF)), Color.FromArgb(unchecked((int)0xFFB599D7)), Color.FromArgb(unchecked((int)0xFFA50149)), Color.FromArgb(unchecked((int)0xFF4E0025)), Color.FromArgb(unchecked((int)0xFFC9B1A9)),
            Color.FromArgb(unchecked((int)0xFF03919A)), Color.FromArgb(unchecked((int)0xFF1B2A25)), Color.FromArgb(unchecked((int)0xFFE500F1)), Color.FromArgb(unchecked((int)0xFF982E0B)), Color.FromArgb(unchecked((int)0xFFB67180)), Color.FromArgb(unchecked((int)0xFFE05859)), Color.FromArgb(unchecked((int)0xFF006039)), Color.FromArgb(unchecked((int)0xFF578F9B)),
            Color.FromArgb(unchecked((int)0xFF305230)), Color.FromArgb(unchecked((int)0xFFCE934C)), Color.FromArgb(unchecked((int)0xFFB3C2BE)), Color.FromArgb(unchecked((int)0xFFC0BAC0)), Color.FromArgb(unchecked((int)0xFFB506D3)), Color.FromArgb(unchecked((int)0xFF170C10)), Color.FromArgb(unchecked((int)0xFF4C534F)), Color.FromArgb(unchecked((int)0xFF224451)),
            Color.FromArgb(unchecked((int)0xFF3E4141)), Color.FromArgb(unchecked((int)0xFF78726D)), Color.FromArgb(unchecked((int)0xFFB6602B)), Color.FromArgb(unchecked((int)0xFF200441)), Color.FromArgb(unchecked((int)0xFFDDB588)), Color.FromArgb(unchecked((int)0xFF497200)), Color.FromArgb(unchecked((int)0xFFC5AAB6)), Color.FromArgb(unchecked((int)0xFF033C61)),
            Color.FromArgb(unchecked((int)0xFF71B2F5)), Color.FromArgb(unchecked((int)0xFFA9E088)), Color.FromArgb(unchecked((int)0xFF4979B0)), Color.FromArgb(unchecked((int)0xFFA2C3DF)), Color.FromArgb(unchecked((int)0xFF784149)), Color.FromArgb(unchecked((int)0xFF2D2B17)), Color.FromArgb(unchecked((int)0xFF3E0E2F)), Color.FromArgb(unchecked((int)0xFF57344C)),
            Color.FromArgb(unchecked((int)0xFF0091BE)), Color.FromArgb(unchecked((int)0xFFE451D1)), Color.FromArgb(unchecked((int)0xFF4B4B6A)), Color.FromArgb(unchecked((int)0xFF5C011A)), Color.FromArgb(unchecked((int)0xFF7C8060)), Color.FromArgb(unchecked((int)0xFFFF9491)), Color.FromArgb(unchecked((int)0xFF4C325D)), Color.FromArgb(unchecked((int)0xFF005C8B)),
            Color.FromArgb(unchecked((int)0xFFE5FDA4)), Color.FromArgb(unchecked((int)0xFF68D1B6)), Color.FromArgb(unchecked((int)0xFF032641)), Color.FromArgb(unchecked((int)0xFF140023)), Color.FromArgb(unchecked((int)0xFF8683A9)), Color.FromArgb(unchecked((int)0xFFCFFF00)), Color.FromArgb(unchecked((int)0xFFA72C3E)), Color.FromArgb(unchecked((int)0xFF34475A)),
            Color.FromArgb(unchecked((int)0xFFB1BB9A)), Color.FromArgb(unchecked((int)0xFFB4A04F)), Color.FromArgb(unchecked((int)0xFF8D918E)), Color.FromArgb(unchecked((int)0xFFA168A6)), Color.FromArgb(unchecked((int)0xFF813D3A)), Color.FromArgb(unchecked((int)0xFF425218)), Color.FromArgb(unchecked((int)0xFFDA8386)), Color.FromArgb(unchecked((int)0xFF776133)),
            Color.FromArgb(unchecked((int)0xFF563930)), Color.FromArgb(unchecked((int)0xFF8498AE)), Color.FromArgb(unchecked((int)0xFF90C1D3)), Color.FromArgb(unchecked((int)0xFFB5666B)), Color.FromArgb(unchecked((int)0xFF9B585E)), Color.FromArgb(unchecked((int)0xFF856465)), Color.FromArgb(unchecked((int)0xFFAD7C90)), Color.FromArgb(unchecked((int)0xFFE2BC00)),
            Color.FromArgb(unchecked((int)0xFFE3AAE0)), Color.FromArgb(unchecked((int)0xFFB2C2FE)), Color.FromArgb(unchecked((int)0xFFFD0039)), Color.FromArgb(unchecked((int)0xFF009B75)), Color.FromArgb(unchecked((int)0xFFFFF46D)), Color.FromArgb(unchecked((int)0xFFE87EAC)), Color.FromArgb(unchecked((int)0xFFDFE3E6)), Color.FromArgb(unchecked((int)0xFF848590)),
            Color.FromArgb(unchecked((int)0xFFAA9297)), Color.FromArgb(unchecked((int)0xFF83A193)), Color.FromArgb(unchecked((int)0xFF577977)), Color.FromArgb(unchecked((int)0xFF3E7158)), Color.FromArgb(unchecked((int)0xFFC64289)), Color.FromArgb(unchecked((int)0xFFEA0072)), Color.FromArgb(unchecked((int)0xFFC4A8CB)), Color.FromArgb(unchecked((int)0xFF55C899)),
            Color.FromArgb(unchecked((int)0xFFE78FCF)), Color.FromArgb(unchecked((int)0xFF004547)), Color.FromArgb(unchecked((int)0xFFF6E2E3)), Color.FromArgb(unchecked((int)0xFF966716)), Color.FromArgb(unchecked((int)0xFF378FDB)), Color.FromArgb(unchecked((int)0xFF435E6A)), Color.FromArgb(unchecked((int)0xFFDA0004)), Color.FromArgb(unchecked((int)0xFF1B000F)),
            Color.FromArgb(unchecked((int)0xFF5B9C8F)), Color.FromArgb(unchecked((int)0xFF6E2B52)), Color.FromArgb(unchecked((int)0xFF011115)), Color.FromArgb(unchecked((int)0xFFE3E8C4)), Color.FromArgb(unchecked((int)0xFFAE3B85)), Color.FromArgb(unchecked((int)0xFFEA1CA9)), Color.FromArgb(unchecked((int)0xFFFF9E6B)), Color.FromArgb(unchecked((int)0xFF457D8B)),
            Color.FromArgb(unchecked((int)0xFF92678B)), Color.FromArgb(unchecked((int)0xFF00CDBB)), Color.FromArgb(unchecked((int)0xFF9CCC04)), Color.FromArgb(unchecked((int)0xFF002E38)), Color.FromArgb(unchecked((int)0xFF96C57F)), Color.FromArgb(unchecked((int)0xFFCFF6B4)), Color.FromArgb(unchecked((int)0xFF492818)), Color.FromArgb(unchecked((int)0xFF766E52)),
            Color.FromArgb(unchecked((int)0xFF20370E)), Color.FromArgb(unchecked((int)0xFFE3D19F)), Color.FromArgb(unchecked((int)0xFF2E3C30)), Color.FromArgb(unchecked((int)0xFFB2EACE)), Color.FromArgb(unchecked((int)0xFFF3BDA4)), Color.FromArgb(unchecked((int)0xFFA24E3D)), Color.FromArgb(unchecked((int)0xFF976FD9)), Color.FromArgb(unchecked((int)0xFF8C9FA8)),
            Color.FromArgb(unchecked((int)0xFF7C2B73)), Color.FromArgb(unchecked((int)0xFF4E5F37)), Color.FromArgb(unchecked((int)0xFF5D5462)), Color.FromArgb(unchecked((int)0xFF90956F)), Color.FromArgb(unchecked((int)0xFF6AA776)), Color.FromArgb(unchecked((int)0xFFDBCBF6)), Color.FromArgb(unchecked((int)0xFFDA71FF)), Color.FromArgb(unchecked((int)0xFF987C95)),
            Color.FromArgb(unchecked((int)0xFF52323C)), Color.FromArgb(unchecked((int)0xFFBB3C42)), Color.FromArgb(unchecked((int)0xFF584D39)), Color.FromArgb(unchecked((int)0xFF4FC15F)), Color.FromArgb(unchecked((int)0xFFA2B9C1)), Color.FromArgb(unchecked((int)0xFF79DB21)), Color.FromArgb(unchecked((int)0xFF1D5958)), Color.FromArgb(unchecked((int)0xFFBD744E)),
            Color.FromArgb(unchecked((int)0xFF160B00)), Color.FromArgb(unchecked((int)0xFF20221A)), Color.FromArgb(unchecked((int)0xFF6B8295)), Color.FromArgb(unchecked((int)0xFF00E0E4)), Color.FromArgb(unchecked((int)0xFF102401)), Color.FromArgb(unchecked((int)0xFF1B782A)), Color.FromArgb(unchecked((int)0xFFDAA9B5)), Color.FromArgb(unchecked((int)0xFFB0415D)),
            Color.FromArgb(unchecked((int)0xFF859253)), Color.FromArgb(unchecked((int)0xFF97A094)), Color.FromArgb(unchecked((int)0xFF06E3C4)), Color.FromArgb(unchecked((int)0xFF47688C)), Color.FromArgb(unchecked((int)0xFF7C6755)), Color.FromArgb(unchecked((int)0xFF075C00)), Color.FromArgb(unchecked((int)0xFF7560D5)), Color.FromArgb(unchecked((int)0xFF7D9F00)),
            Color.FromArgb(unchecked((int)0xFFC36D96)), Color.FromArgb(unchecked((int)0xFF4D913E)), Color.FromArgb(unchecked((int)0xFF5F4276)), Color.FromArgb(unchecked((int)0xFFFCE4C8)), Color.FromArgb(unchecked((int)0xFF303052)), Color.FromArgb(unchecked((int)0xFF4F381B)), Color.FromArgb(unchecked((int)0xFFE5A532)), Color.FromArgb(unchecked((int)0xFF706690)),
            Color.FromArgb(unchecked((int)0xFFAA9A92)), Color.FromArgb(unchecked((int)0xFF237363)), Color.FromArgb(unchecked((int)0xFF73013E)), Color.FromArgb(unchecked((int)0xFFFF9079)), Color.FromArgb(unchecked((int)0xFFA79A74)), Color.FromArgb(unchecked((int)0xFF029BDB)), Color.FromArgb(unchecked((int)0xFFFF0169)), Color.FromArgb(unchecked((int)0xFFC7D2E7)),
            Color.FromArgb(unchecked((int)0xFFCA8869)), Color.FromArgb(unchecked((int)0xFF80FFCD)), Color.FromArgb(unchecked((int)0xFFBB1F69)), Color.FromArgb(unchecked((int)0xFF90B0AB)), Color.FromArgb(unchecked((int)0xFF7D74A9)), Color.FromArgb(unchecked((int)0xFFFCC7DB)), Color.FromArgb(unchecked((int)0xFF99375B)), Color.FromArgb(unchecked((int)0xFF00AB4D)),
            Color.FromArgb(unchecked((int)0xFFABAED1)), Color.FromArgb(unchecked((int)0xFFBE9D91)), Color.FromArgb(unchecked((int)0xFFE6E5A7)), Color.FromArgb(unchecked((int)0xFF332C22)), Color.FromArgb(unchecked((int)0xFFDD587B)), Color.FromArgb(unchecked((int)0xFFF5FFF7)), Color.FromArgb(unchecked((int)0xFF5D3033)), Color.FromArgb(unchecked((int)0xFF6D3800)),
            Color.FromArgb(unchecked((int)0xFFFF0020)), Color.FromArgb(unchecked((int)0xFFB57BB3)), Color.FromArgb(unchecked((int)0xFFD7FFE6)), Color.FromArgb(unchecked((int)0xFFC535A9)), Color.FromArgb(unchecked((int)0xFF260009)), Color.FromArgb(unchecked((int)0xFF6A8781)), Color.FromArgb(unchecked((int)0xFFA8ABB4)), Color.FromArgb(unchecked((int)0xFFD45262)),
            Color.FromArgb(unchecked((int)0xFF794B61)), Color.FromArgb(unchecked((int)0xFF4621B2)), Color.FromArgb(unchecked((int)0xFF8DA4DB)), Color.FromArgb(unchecked((int)0xFFC7C890)), Color.FromArgb(unchecked((int)0xFF6FE9AD)), Color.FromArgb(unchecked((int)0xFFA243A7)), Color.FromArgb(unchecked((int)0xFFB2B081)), Color.FromArgb(unchecked((int)0xFF181B00)),
            Color.FromArgb(unchecked((int)0xFF286154)), Color.FromArgb(unchecked((int)0xFF4CA43B)), Color.FromArgb(unchecked((int)0xFF6A9573)), Color.FromArgb(unchecked((int)0xFFA8441D)), Color.FromArgb(unchecked((int)0xFF5C727B)), Color.FromArgb(unchecked((int)0xFF738671)), Color.FromArgb(unchecked((int)0xFFD0CFCB)), Color.FromArgb(unchecked((int)0xFF897B77)),
            Color.FromArgb(unchecked((int)0xFF1F3F22)), Color.FromArgb(unchecked((int)0xFF4145A7)), Color.FromArgb(unchecked((int)0xFFDA9894)), Color.FromArgb(unchecked((int)0xFFA1757A)), Color.FromArgb(unchecked((int)0xFF63243C)), Color.FromArgb(unchecked((int)0xFFADAAFF)), Color.FromArgb(unchecked((int)0xFF00CDE2)), Color.FromArgb(unchecked((int)0xFFDDBC62)),
            Color.FromArgb(unchecked((int)0xFF698EB1)), Color.FromArgb(unchecked((int)0xFF208462)), Color.FromArgb(unchecked((int)0xFF00B7E0)), Color.FromArgb(unchecked((int)0xFF614A44)), Color.FromArgb(unchecked((int)0xFF9BBB57)), Color.FromArgb(unchecked((int)0xFF7A5C54)), Color.FromArgb(unchecked((int)0xFF857A50)), Color.FromArgb(unchecked((int)0xFF766B7E)),
            Color.FromArgb(unchecked((int)0xFF014833)), Color.FromArgb(unchecked((int)0xFFFF8347)), Color.FromArgb(unchecked((int)0xFF7A8EBA)), Color.FromArgb(unchecked((int)0xFF274740)), Color.FromArgb(unchecked((int)0xFF946444)), Color.FromArgb(unchecked((int)0xFFEBD8E6)), Color.FromArgb(unchecked((int)0xFF646241)), Color.FromArgb(unchecked((int)0xFF373917)),
            Color.FromArgb(unchecked((int)0xFF6AD450)), Color.FromArgb(unchecked((int)0xFF81817B)), Color.FromArgb(unchecked((int)0xFFD499E3)), Color.FromArgb(unchecked((int)0xFF979440)), Color.FromArgb(unchecked((int)0xFF011A12)), Color.FromArgb(unchecked((int)0xFF526554)), Color.FromArgb(unchecked((int)0xFFB5885C)), Color.FromArgb(unchecked((int)0xFFA499A5)),
            Color.FromArgb(unchecked((int)0xFF03AD89)), Color.FromArgb(unchecked((int)0xFFB3008B)), Color.FromArgb(unchecked((int)0xFFE3C4B5)), Color.FromArgb(unchecked((int)0xFF96531F)), Color.FromArgb(unchecked((int)0xFF867175)), Color.FromArgb(unchecked((int)0xFF74569E)), Color.FromArgb(unchecked((int)0xFF617D9F)), Color.FromArgb(unchecked((int)0xFFE70452)),
            Color.FromArgb(unchecked((int)0xFF067EAF)), Color.FromArgb(unchecked((int)0xFFA697B6)), Color.FromArgb(unchecked((int)0xFFB787A8)), Color.FromArgb(unchecked((int)0xFF9CFF93)), Color.FromArgb(unchecked((int)0xFF311D19)), Color.FromArgb(unchecked((int)0xFF3A9459)), Color.FromArgb(unchecked((int)0xFF6E746E)), Color.FromArgb(unchecked((int)0xFFB0C5AE)),
            Color.FromArgb(unchecked((int)0xFF84EDF7)), Color.FromArgb(unchecked((int)0xFFED3488)), Color.FromArgb(unchecked((int)0xFF754C78)), Color.FromArgb(unchecked((int)0xFF384644)), Color.FromArgb(unchecked((int)0xFFC7847B)), Color.FromArgb(unchecked((int)0xFF00B6C5)), Color.FromArgb(unchecked((int)0xFF7FA670)), Color.FromArgb(unchecked((int)0xFFC1AF9E)),
            Color.FromArgb(unchecked((int)0xFF2A7FFF)), Color.FromArgb(unchecked((int)0xFF72A58C)), Color.FromArgb(unchecked((int)0xFFFFC07F)), Color.FromArgb(unchecked((int)0xFF9DEBDD)), Color.FromArgb(unchecked((int)0xFFD97C8E)), Color.FromArgb(unchecked((int)0xFF7E7C93)), Color.FromArgb(unchecked((int)0xFF62E674)), Color.FromArgb(unchecked((int)0xFFB5639E)),
            Color.FromArgb(unchecked((int)0xFFFFA861)), Color.FromArgb(unchecked((int)0xFFC2A580)), Color.FromArgb(unchecked((int)0xFF8D9C83)), Color.FromArgb(unchecked((int)0xFFB70546)), Color.FromArgb(unchecked((int)0xFF372B2E)), Color.FromArgb(unchecked((int)0xFF0098FF)), Color.FromArgb(unchecked((int)0xFF985975)), Color.FromArgb(unchecked((int)0xFF20204C)),
            Color.FromArgb(unchecked((int)0xFFFF6C60)), Color.FromArgb(unchecked((int)0xFF445083)), Color.FromArgb(unchecked((int)0xFF8502AA)), Color.FromArgb(unchecked((int)0xFF72361F)), Color.FromArgb(unchecked((int)0xFF9676A3)), Color.FromArgb(unchecked((int)0xFF484449)), Color.FromArgb(unchecked((int)0xFFCED6C2)), Color.FromArgb(unchecked((int)0xFF3B164A)),
            Color.FromArgb(unchecked((int)0xFFCCA763)), Color.FromArgb(unchecked((int)0xFF2C7F77)), Color.FromArgb(unchecked((int)0xFF02227B)), Color.FromArgb(unchecked((int)0xFFA37E6F)), Color.FromArgb(unchecked((int)0xFFCDE6DC)), Color.FromArgb(unchecked((int)0xFFCDFFFB)), Color.FromArgb(unchecked((int)0xFFBE811A)), Color.FromArgb(unchecked((int)0xFFF77183)),
            Color.FromArgb(unchecked((int)0xFFEDE6E2)), Color.FromArgb(unchecked((int)0xFFCDC6B4)), Color.FromArgb(unchecked((int)0xFFFFE09E)), Color.FromArgb(unchecked((int)0xFF3A7271)), Color.FromArgb(unchecked((int)0xFFFF7B59)), Color.FromArgb(unchecked((int)0xFF4E4E01)), Color.FromArgb(unchecked((int)0xFF4AC684)), Color.FromArgb(unchecked((int)0xFF8BC891)),
            Color.FromArgb(unchecked((int)0xFFBC8A96)), Color.FromArgb(unchecked((int)0xFFCF6353)), Color.FromArgb(unchecked((int)0xFFDCDE5C)), Color.FromArgb(unchecked((int)0xFF5EAADD)), Color.FromArgb(unchecked((int)0xFFF6A0AD)), Color.FromArgb(unchecked((int)0xFFE269AA)), Color.FromArgb(unchecked((int)0xFFA3DAE4)), Color.FromArgb(unchecked((int)0xFF436E83)),
            Color.FromArgb(unchecked((int)0xFF002E17)), Color.FromArgb(unchecked((int)0xFFECFBFF)), Color.FromArgb(unchecked((int)0xFFA1C2B6)), Color.FromArgb(unchecked((int)0xFF50003F)), Color.FromArgb(unchecked((int)0xFF71695B)), Color.FromArgb(unchecked((int)0xFF67C4BB)), Color.FromArgb(unchecked((int)0xFF536EFF)), Color.FromArgb(unchecked((int)0xFF5D5A48)),
            Color.FromArgb(unchecked((int)0xFF890039)), Color.FromArgb(unchecked((int)0xFF969381)), Color.FromArgb(unchecked((int)0xFF371521)), Color.FromArgb(unchecked((int)0xFF5E4665)), Color.FromArgb(unchecked((int)0xFFAA62C3)), Color.FromArgb(unchecked((int)0xFF8D6F81)), Color.FromArgb(unchecked((int)0xFF2C6135)), Color.FromArgb(unchecked((int)0xFF410601)),
            Color.FromArgb(unchecked((int)0xFF564620)), Color.FromArgb(unchecked((int)0xFFE69034)), Color.FromArgb(unchecked((int)0xFF6DA6BD)), Color.FromArgb(unchecked((int)0xFFE58E56)), Color.FromArgb(unchecked((int)0xFFE3A68B)), Color.FromArgb(unchecked((int)0xFF48B176)), Color.FromArgb(unchecked((int)0xFFD27D67)), Color.FromArgb(unchecked((int)0xFFB5B268)),
            Color.FromArgb(unchecked((int)0xFF7F8427)), Color.FromArgb(unchecked((int)0xFFFF84E6)), Color.FromArgb(unchecked((int)0xFF435740)), Color.FromArgb(unchecked((int)0xFFEAE408)), Color.FromArgb(unchecked((int)0xFFF4F5FF)), Color.FromArgb(unchecked((int)0xFF325800)), Color.FromArgb(unchecked((int)0xFF4B6BA5)), Color.FromArgb(unchecked((int)0xFFADCEFF)),
            Color.FromArgb(unchecked((int)0xFF9B8ACC)), Color.FromArgb(unchecked((int)0xFF885138)), Color.FromArgb(unchecked((int)0xFF5875C1)), Color.FromArgb(unchecked((int)0xFF7E7311)), Color.FromArgb(unchecked((int)0xFFFEA5CA)), Color.FromArgb(unchecked((int)0xFF9F8B5B)), Color.FromArgb(unchecked((int)0xFFA55B54)), Color.FromArgb(unchecked((int)0xFF89006A)),
            Color.FromArgb(unchecked((int)0xFFAF756F)), Color.FromArgb(unchecked((int)0xFF2A2000)), Color.FromArgb(unchecked((int)0xFF576E4A)), Color.FromArgb(unchecked((int)0xFF7F9EFF)), Color.FromArgb(unchecked((int)0xFF7499A1)), Color.FromArgb(unchecked((int)0xFFFFB550)), Color.FromArgb(unchecked((int)0xFF00011E)), Color.FromArgb(unchecked((int)0xFFD1511C)),
            Color.FromArgb(unchecked((int)0xFF688151)), Color.FromArgb(unchecked((int)0xFFBC908A)), Color.FromArgb(unchecked((int)0xFF78C8EB)), Color.FromArgb(unchecked((int)0xFF8502FF)), Color.FromArgb(unchecked((int)0xFF483D30)), Color.FromArgb(unchecked((int)0xFFC42221)), Color.FromArgb(unchecked((int)0xFF5EA7FF)), Color.FromArgb(unchecked((int)0xFF785715)),
            Color.FromArgb(unchecked((int)0xFF0CEA91)), Color.FromArgb(unchecked((int)0xFFFFFAED)), Color.FromArgb(unchecked((int)0xFFB3AF9D)), Color.FromArgb(unchecked((int)0xFF3E3D52)), Color.FromArgb(unchecked((int)0xFF5A9BC2)), Color.FromArgb(unchecked((int)0xFF9C2F90)), Color.FromArgb(unchecked((int)0xFF8D5700)), Color.FromArgb(unchecked((int)0xFFADD79C)),
            Color.FromArgb(unchecked((int)0xFF00768B)), Color.FromArgb(unchecked((int)0xFF337D00)), Color.FromArgb(unchecked((int)0xFFC59700)), Color.FromArgb(unchecked((int)0xFF3156DC)), Color.FromArgb(unchecked((int)0xFF944575)), Color.FromArgb(unchecked((int)0xFFECFFDC)), Color.FromArgb(unchecked((int)0xFFD24CB2)), Color.FromArgb(unchecked((int)0xFF97703C)),
            Color.FromArgb(unchecked((int)0xFF4C257F)), Color.FromArgb(unchecked((int)0xFF9E0366)), Color.FromArgb(unchecked((int)0xFF88FFEC)), Color.FromArgb(unchecked((int)0xFFB56481)), Color.FromArgb(unchecked((int)0xFF396D2B)), Color.FromArgb(unchecked((int)0xFF56735F)), Color.FromArgb(unchecked((int)0xFF988376)), Color.FromArgb(unchecked((int)0xFF9BB195)),
            Color.FromArgb(unchecked((int)0xFFA9795C)), Color.FromArgb(unchecked((int)0xFFE4C5D3)), Color.FromArgb(unchecked((int)0xFF9F4F67)), Color.FromArgb(unchecked((int)0xFF1E2B39)), Color.FromArgb(unchecked((int)0xFF664327)), Color.FromArgb(unchecked((int)0xFFAFCE78)), Color.FromArgb(unchecked((int)0xFF322EDF)), Color.FromArgb(unchecked((int)0xFF86B487)),
            Color.FromArgb(unchecked((int)0xFFC23000)), Color.FromArgb(unchecked((int)0xFFABE86B)), Color.FromArgb(unchecked((int)0xFF96656D)), Color.FromArgb(unchecked((int)0xFF250E35)), Color.FromArgb(unchecked((int)0xFFA60019)), Color.FromArgb(unchecked((int)0xFF0080CF)), Color.FromArgb(unchecked((int)0xFFCAEFFF)), Color.FromArgb(unchecked((int)0xFF323F61)),
            Color.FromArgb(unchecked((int)0xFFA449DC)), Color.FromArgb(unchecked((int)0xFF6A9D3B)), Color.FromArgb(unchecked((int)0xFFFF5AE4)), Color.FromArgb(unchecked((int)0xFF636A01)), Color.FromArgb(unchecked((int)0xFFD16CDA)), Color.FromArgb(unchecked((int)0xFF736060)), Color.FromArgb(unchecked((int)0xFFFFBAAD)), Color.FromArgb(unchecked((int)0xFFD369B4)),
            Color.FromArgb(unchecked((int)0xFFFFDED6)), Color.FromArgb(unchecked((int)0xFF6C6D74)), Color.FromArgb(unchecked((int)0xFF927D5E)), Color.FromArgb(unchecked((int)0xFF845D70)), Color.FromArgb(unchecked((int)0xFF5B62C1)), Color.FromArgb(unchecked((int)0xFF2F4A36)), Color.FromArgb(unchecked((int)0xFFE45F35)), Color.FromArgb(unchecked((int)0xFFFF3B53)),
            Color.FromArgb(unchecked((int)0xFFAC84DD)), Color.FromArgb(unchecked((int)0xFF762988)), Color.FromArgb(unchecked((int)0xFF70EC98)), Color.FromArgb(unchecked((int)0xFF408543)), Color.FromArgb(unchecked((int)0xFF2C3533)), Color.FromArgb(unchecked((int)0xFF2E182D)), Color.FromArgb(unchecked((int)0xFF323925)), Color.FromArgb(unchecked((int)0xFF19181B)),
            Color.FromArgb(unchecked((int)0xFF2F2E2C)), Color.FromArgb(unchecked((int)0xFF023C32)), Color.FromArgb(unchecked((int)0xFF9B9EE2)), Color.FromArgb(unchecked((int)0xFF58AFAD)), Color.FromArgb(unchecked((int)0xFF5C424D)), Color.FromArgb(unchecked((int)0xFF7AC5A6)), Color.FromArgb(unchecked((int)0xFF685D75)), Color.FromArgb(unchecked((int)0xFFB9BCBD)),
            Color.FromArgb(unchecked((int)0xFF834357)), Color.FromArgb(unchecked((int)0xFF1A7B42)), Color.FromArgb(unchecked((int)0xFF2E57AA)), Color.FromArgb(unchecked((int)0xFFE55199)), Color.FromArgb(unchecked((int)0xFF316E47)), Color.FromArgb(unchecked((int)0xFFCD00C5)), Color.FromArgb(unchecked((int)0xFF6A004D)), Color.FromArgb(unchecked((int)0xFF7FBBEC)),
            Color.FromArgb(unchecked((int)0xFFF35691)), Color.FromArgb(unchecked((int)0xFFD7C54A)), Color.FromArgb(unchecked((int)0xFF62ACB7)), Color.FromArgb(unchecked((int)0xFFCBA1BC)), Color.FromArgb(unchecked((int)0xFFA28A9A)), Color.FromArgb(unchecked((int)0xFF6C3F3B)), Color.FromArgb(unchecked((int)0xFFFFE47D)), Color.FromArgb(unchecked((int)0xFFDCBAE3)),
            Color.FromArgb(unchecked((int)0xFF5F816D)), Color.FromArgb(unchecked((int)0xFF3A404A)), Color.FromArgb(unchecked((int)0xFF7DBF32)), Color.FromArgb(unchecked((int)0xFFE6ECDC)), Color.FromArgb(unchecked((int)0xFF852C19)), Color.FromArgb(unchecked((int)0xFF285366)), Color.FromArgb(unchecked((int)0xFFB8CB9C)), Color.FromArgb(unchecked((int)0xFF0E0D00)),
            Color.FromArgb(unchecked((int)0xFF4B5D56)), Color.FromArgb(unchecked((int)0xFF6B543F)), Color.FromArgb(unchecked((int)0xFFE27172)), Color.FromArgb(unchecked((int)0xFF0568EC)), Color.FromArgb(unchecked((int)0xFF2EB500)), Color.FromArgb(unchecked((int)0xFFD21656)), Color.FromArgb(unchecked((int)0xFFEFAFFF)), Color.FromArgb(unchecked((int)0xFF682021)),
            Color.FromArgb(unchecked((int)0xFF2D2011)), Color.FromArgb(unchecked((int)0xFFDA4CFF)), Color.FromArgb(unchecked((int)0xFF70968E)), Color.FromArgb(unchecked((int)0xFFFF7B7D)), Color.FromArgb(unchecked((int)0xFF4A1930)), Color.FromArgb(unchecked((int)0xFFE8C282)), Color.FromArgb(unchecked((int)0xFFE7DBBC)), Color.FromArgb(unchecked((int)0xFFA68486)),
            Color.FromArgb(unchecked((int)0xFF1F263C)), Color.FromArgb(unchecked((int)0xFF36574E)), Color.FromArgb(unchecked((int)0xFF52CE79)), Color.FromArgb(unchecked((int)0xFFADAAA9)), Color.FromArgb(unchecked((int)0xFF8A9F45)), Color.FromArgb(unchecked((int)0xFF6542D2)), Color.FromArgb(unchecked((int)0xFF00FB8C)), Color.FromArgb(unchecked((int)0xFF5D697B)),
            Color.FromArgb(unchecked((int)0xFFCCD27F)), Color.FromArgb(unchecked((int)0xFF94A5A1)), Color.FromArgb(unchecked((int)0xFF790229)), Color.FromArgb(unchecked((int)0xFFE383E6)), Color.FromArgb(unchecked((int)0xFF7EA4C1)), Color.FromArgb(unchecked((int)0xFF4E4452)), Color.FromArgb(unchecked((int)0xFF4B2C00)), Color.FromArgb(unchecked((int)0xFF620B70)),
            Color.FromArgb(unchecked((int)0xFF314C1E)), Color.FromArgb(unchecked((int)0xFF874AA6)), Color.FromArgb(unchecked((int)0xFFE30091)), Color.FromArgb(unchecked((int)0xFF66460A)), Color.FromArgb(unchecked((int)0xFFEB9A8B)), Color.FromArgb(unchecked((int)0xFFEAC3A3)), Color.FromArgb(unchecked((int)0xFF98EAB3)), Color.FromArgb(unchecked((int)0xFFAB9180)),
            Color.FromArgb(unchecked((int)0xFFB8552F)), Color.FromArgb(unchecked((int)0xFF1A2B2F)), Color.FromArgb(unchecked((int)0xFF94DDC5)), Color.FromArgb(unchecked((int)0xFF9D8C76)), Color.FromArgb(unchecked((int)0xFF9C8333)), Color.FromArgb(unchecked((int)0xFF94A9C9)), Color.FromArgb(unchecked((int)0xFF392935)), Color.FromArgb(unchecked((int)0xFF8C675E)),
            Color.FromArgb(unchecked((int)0xFFCCE93A)), Color.FromArgb(unchecked((int)0xFF917100)), Color.FromArgb(unchecked((int)0xFF01400B)), Color.FromArgb(unchecked((int)0xFF449896)), Color.FromArgb(unchecked((int)0xFF1CA370)), Color.FromArgb(unchecked((int)0xFFE08DA7)), Color.FromArgb(unchecked((int)0xFF8B4A4E)), Color.FromArgb(unchecked((int)0xFF667776)),
            Color.FromArgb(unchecked((int)0xFF4692AD)), Color.FromArgb(unchecked((int)0xFF67BDA8)), Color.FromArgb(unchecked((int)0xFF69255C)), Color.FromArgb(unchecked((int)0xFFD3BFFF)), Color.FromArgb(unchecked((int)0xFF4A5132)), Color.FromArgb(unchecked((int)0xFF7E9285)), Color.FromArgb(unchecked((int)0xFF77733C)), Color.FromArgb(unchecked((int)0xFFE7A0CC)),
            Color.FromArgb(unchecked((int)0xFF51A288)), Color.FromArgb(unchecked((int)0xFF2C656A)), Color.FromArgb(unchecked((int)0xFF4D5C5E)), Color.FromArgb(unchecked((int)0xFFC9403A)), Color.FromArgb(unchecked((int)0xFFDDD7F3)), Color.FromArgb(unchecked((int)0xFF005844)), Color.FromArgb(unchecked((int)0xFFB4A200)), Color.FromArgb(unchecked((int)0xFF488F69)),
            Color.FromArgb(unchecked((int)0xFF858182)), Color.FromArgb(unchecked((int)0xFFD4E9B9)), Color.FromArgb(unchecked((int)0xFF3D7397)), Color.FromArgb(unchecked((int)0xFFCAE8CE)), Color.FromArgb(unchecked((int)0xFFD60034)), Color.FromArgb(unchecked((int)0xFFAA6746)), Color.FromArgb(unchecked((int)0xFF9E5585)), Color.FromArgb(unchecked((int)0xFFBA6200))
        };

        public static HSLColor ToHSL(this Color c) { return HSLColor.FromColor(c); }
    }

    /// <summary>
    /// HSL / HSV color representation from https://stackoverflow.com/a/4794649/294998
    /// </summary>
    public class HSLColor
    {
        // Hue just allow to select the color, 0  or 1 is Red,
        public float Hue;
        // Saturation means is like saying the color of an object is _not_ impacted by time
        // The max value means the object is completely "new" so the color is "beautiful",
        // over time the color goes to gray. All colors goes to gray with time.
        // At infinite time the saturation is 0, all color with saturation are the same : gray
        public float Saturation;
        // Luminosity is like how "hot" the object is, when the object is very very very hot the light is white
        // when the object is very cold, object is black (there is no sun)
        // so with a 50% of "hotness" you get the the beautiful color
        public float Luminosity;

        public HSLColor(float h, float s, float l)
        {
            Hue = h;
            Saturation = s;
            Luminosity = l;
        }

        public static HSLColor FromColor(Color c) { return FromRGB(c.R, c.G, c.B); }
        public static HSLColor FromRGB(byte r, byte g, byte b)
        {
            float _r = r / 255f;
            float _g = g / 255f;
            float _b = b / 255f;

            float _min = Math.Min(Math.Min(_r, _g), _b);
            float _max = Math.Max(Math.Max(_r, _g), _b);
            float _delta = _max - _min;

            float h = 0;
            float s = 0;
            float l = (_max + _min) / 2.0f;

            if (_delta != 0)
            {
                if (l < 0.5f)
                    s = _delta / (_max + _min);
                else
                    s = _delta / (2.0f - _max - _min);


                if (_r == _max)
                    h = (_g - _b) / _delta;
                else if (_g == _max)
                    h = 2f + (_b - _r) / _delta;
                else if (_b == _max)
                    h = 4f + (_r - _g) / _delta;
            }

            return new HSLColor(h, s, l);
        }
        public Color ToRGB()
        {
            byte r, g, b;
            if (Saturation == 0)
            {
                r = (byte)Math.Round(Luminosity * 255d);
                g = (byte)Math.Round(Luminosity * 255d);
                b = (byte)Math.Round(Luminosity * 255d);
            }
            else
            {
                double t1, t2;
                double th = Hue / 6.0d;

                if (Luminosity < 0.5d)
                {
                    t2 = Luminosity * (1d + Saturation);
                }
                else
                {
                    t2 = (Luminosity + Saturation) - (Luminosity * Saturation);
                }
                t1 = 2d * Luminosity - t2;

                double tr, tg, tb;
                tr = th + (1.0d / 3.0d);
                tg = th;
                tb = th - (1.0d / 3.0d);

                tr = ColorCalc(tr, t1, t2);
                tg = ColorCalc(tg, t1, t2);
                tb = ColorCalc(tb, t1, t2);
                r = (byte)Math.Round(tr * 255d);
                g = (byte)Math.Round(tg * 255d);
                b = (byte)Math.Round(tb * 255d);
            }
            return Color.FromArgb(r, g, b);
        }
        static double ColorCalc(double c, double t1, double t2)
        {

            if (c < 0) c += 1d;
            if (c > 1) c -= 1d;
            if (6.0d * c < 1.0d) return t1 + (t2 - t1) * 6.0d * c;
            if (2.0d * c < 1.0d) return t2;
            if (3.0d * c < 2.0d) return t1 + (t2 - t1) * (2.0d / 3.0d - c) * 6.0d;
            return t1;
        }
    }

}
